namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *atomic_reduction_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2021-2023 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/ocl/ocl_types.h")==""\n"
R"==(#if defined(IS_MAX))==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_MIN))==""\n"
R"==(#elif defined(IS_MIN))==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_MAX))==""\n"
R"==(#elif defined(IS_MUL))==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_ONE))==""\n"
R"==(#else)==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_ZERO))==""\n"
R"==(#endif)==""\n"
R"==(#if defined(SRC_DT_S8) || defined(SRC_DT_U8) || defined(SRC_DT_S32))==""\n"
R"==(#define MAX_FUNC max)==""\n"
R"==(#define MIN_FUNC min)==""\n"
R"==(#else)==""\n"
R"==(#define MAX_FUNC fmax)==""\n"
R"==(#define MIN_FUNC fmin)==""\n"
R"==(#endif)==""\n"
R"==(#if defined(IS_MAX))==""\n"
R"==(#define ACCUMULATE_INITIAL(x, y) MAX_FUNC(x, y))==""\n"
R"==(#define ATOMIC_ACCUMULATE(atomic_p, data) atomic_max_global(atomic_p, data))==""\n"
R"==(#elif defined(IS_MIN))==""\n"
R"==(#define ACCUMULATE_INITIAL(x, y) MIN_FUNC(x, y))==""\n"
R"==(#define ATOMIC_ACCUMULATE(atomic_p, data) atomic_min_global(atomic_p, data))==""\n"
R"==(#elif defined(IS_MEAN) || defined(IS_SUM))==""\n"
R"==(#define ACCUMULATE_INITIAL(x, y) (x + y))==""\n"
R"==(#define ATOMIC_ACCUMULATE(atomic_p, data) atomic_add_global(atomic_p, data))==""\n"
R"==(#elif defined(IS_MUL))==""\n"
R"==(#define ACCUMULATE_INITIAL(x, y) (x * y))==""\n"
R"==(#else)==""\n"
R"==(#define ACCUMULATE_INITIAL(x, y) (x + pow(fabs(y), POWER)))==""\n"
R"==(#endif)==""\n"
R"==(#if defined(IS_MAX) || defined(IS_MIN) || defined(IS_MEAN) || defined(IS_MUL))==""\n"
R"==(#define ACCUMULATE_FURTHER ACCUMULATE_INITIAL)==""\n"
R"==(#else)==""\n"
R"==(#define ACCUMULATE_FURTHER(x, y) (x + y))==""\n"
R"==(#endif)==""\n"
R"==(#if IS_FIRST)==""\n"
R"==(#define ACCUMULATE ACCUMULATE_INITIAL)==""\n"
R"==(#else)==""\n"
R"==(#define ACCUMULATE ACCUMULATE_FURTHER)==""\n"
R"==(#endif)==""\n"
R"==(#if defined(IS_MEAN))==""\n"
R"==(#define FINALIZE(x) (x / DIV))==""\n"
R"==(#elif defined(IS_LP_MAX))==""\n"
R"==(#define FINALIZE(x) rootn(fmax(x, EPS), POWER))==""\n"
R"==(#elif defined(IS_LP_SUM))==""\n"
R"==(#define FINALIZE(x) rootn(x + EPS, POWER))==""\n"
R"==(#elif defined(IS_P_MAX))==""\n"
R"==(#define FINALIZE(x) fmax(x, EPS))==""\n"
R"==(#elif defined(IS_P_SUM))==""\n"
R"==(#define FINALIZE(x) (x + EPS))==""\n"
R"==(#else)==""\n"
R"==(#define FINALIZE(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#if !IS_FINAL)==""\n"
R"==(#undef FINALIZE)==""\n"
R"==(#define FINALIZE(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#if ATOMIC_REDUCTION_SIZE > 1)==""\n"
R"==(#define ATOMIC(x) CONCAT2(atomic_, x))==""\n"
R"==(#else)==""\n"
R"==(#define ATOMIC(x) x)==""\n"
R"==(#endif)==""\n"
R"==(#define BLOCK_READ_DATA_T(data_ptr) \)==""\n"
R"==(AS_VECT_DATA_T(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)data_ptr)))==""\n"
R"==(#if VECT_DT_N == 1)==""\n"
R"==(#define GET_ELEM(x, idx) (x))==""\n"
R"==(#else)==""\n"
R"==(#define GET_ELEM(x, idx) x[idx])==""\n"
R"==(#endif)==""\n"
R"==(#define WG_PER_INNER (INNER_DIM_SIZE / VECT_DT_N / SUBGROUP_SIZE))==""\n"
R"==(#define SRC_ATOMIC_STRIDE INNER_DIM_SIZE)==""\n"
R"==(#define SRC_LOCAL_STRIDE (SRC_ATOMIC_STRIDE * ATOMIC_REDUCTION_SIZE))==""\n"
R"==(#define SRC_SIMD_STRIDE (SRC_LOCAL_STRIDE * LOCAL_SIZE))==""\n"
R"==(#define SRC_INNER_STRIDE (SUBGROUP_SIZE * VECT_DT_N))==""\n"
R"==(#define SRC_OUTER_STRIDE (REDUCTION_SIZE * INNER_DIM_SIZE))==""\n"
R"==(#define DST_INNER_STRIDE (SUBGROUP_SIZE * VECT_DT_N))==""\n"
R"==(#define DST_OUTER_STRIDE INNER_DIM_SIZE)==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) )==""\n"
R"==(__kernel void)==""\n"
R"==(atomic_reduce(__global SRC_DATA_T *src, __global ATOMIC(DST_DATA_T) * dst) {)==""\n"
R"==(const int sglid = get_global_id(0);)==""\n"
R"==(const int inner_idx = get_global_id(1) % WG_PER_INNER;)==""\n"
R"==(const int outer_idx = get_global_id(1) / WG_PER_INNER;)==""\n"
R"==(const int local_idx = get_global_id(2) % LOCAL_SIZE;)==""\n"
R"==(const int atomic_idx)==""\n"
R"==(= (get_global_id(2) / LOCAL_SIZE) % ATOMIC_REDUCTION_SIZE;)==""\n"
R"==(const int src_off_start = atomic_idx * SRC_ATOMIC_STRIDE)==""\n"
R"==(+ local_idx * SRC_LOCAL_STRIDE + inner_idx * SRC_INNER_STRIDE)==""\n"
R"==(+ outer_idx * SRC_OUTER_STRIDE;)==""\n"
R"==(VECT_DEF_ACC_DATA_T acc = INIT_ACC;)==""\n"
R"==(int i = 0;)==""\n"
R"==(for (; i < REDUCTION_SIZE / ATOMIC_REDUCTION_SIZE / LOCAL_SIZE; i++) {)==""\n"
R"==(const int src_off = src_off_start + i * SRC_SIMD_STRIDE;)==""\n"
R"==(const VECT_DATA_T src_val = BLOCK_READ_DATA_T(&src[src_off]);)==""\n"
R"==(acc = ACCUMULATE(acc, AS_VECT_DEF_ACC_DATA_T(src_val));)==""\n"
R"==(})==""\n"
R"==(const int src_off = src_off_start + i * SRC_SIMD_STRIDE;)==""\n"
R"==(if (src_off < (outer_idx + 1) * SRC_OUTER_STRIDE) {)==""\n"
R"==(const VECT_DATA_T src_val = BLOCK_READ_DATA_T(&src[src_off]);)==""\n"
R"==(acc = ACCUMULATE(acc, AS_VECT_DEF_ACC_DATA_T(src_val));)==""\n"
R"==(})==""\n"
R"==(#if LOCAL_SIZE > 1)==""\n"
R"==(__local DEF_ACC_DATA_T local_acc_buf[LOCAL_SIZE][SUBGROUP_SIZE * VECT_DT_N];)==""\n"
R"==(unroll_for(int i = 0; i < VECT_DT_N; i++) {)==""\n"
R"==(local_acc_buf[local_idx][sglid + i * SUBGROUP_SIZE] = GET_ELEM(acc, i);)==""\n"
R"==(})==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(if (local_idx == 0) {)==""\n"
R"==(VECT_DEF_ACC_DATA_T local_acc = acc;)==""\n"
R"==(for (int slm_off = 1; slm_off < LOCAL_SIZE; slm_off++) {)==""\n"
R"==(for (int v = 0; v < VECT_DT_N; v++) {)==""\n"
R"==(DEF_ACC_DATA_T slm_data)==""\n"
R"==(= local_acc_buf[slm_off][sglid + v * SUBGROUP_SIZE];)==""\n"
R"==(GET_ELEM(local_acc, v))==""\n"
R"==(= ACCUMULATE_FURTHER(GET_ELEM(local_acc, v), slm_data);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==({)==""\n"
R"==(VECT_DEF_ACC_DATA_T local_acc = acc;)==""\n"
R"==(#endif)==""\n"
R"==(const int dst_off = outer_idx * DST_OUTER_STRIDE)==""\n"
R"==(+ inner_idx * DST_INNER_STRIDE + sglid;)==""\n"
R"==(for (int v = 0; v < VECT_DT_N; v++) {)==""\n"
R"==(#if ATOMIC_REDUCTION_SIZE > 1)==""\n"
R"==(DST_DATA_T dst_data = TO_DST(convert_float(GET_ELEM(local_acc, v)));)==""\n"
R"==(DST_DATA_T old_val = ATOMIC_ACCUMULATE()==""\n"
R"==(&dst[dst_off + v * SUBGROUP_SIZE], dst_data);)==""\n"
R"==(#else)==""\n"
R"==(DST_DATA_T dst_data)==""\n"
R"==(= TO_DST(FINALIZE(convert_float(GET_ELEM(local_acc, v))));)==""\n"
R"==(dst[dst_off + v * SUBGROUP_SIZE] = dst_data;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}