namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *combined_reduction_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2021-2023 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/ocl/ocl_types.h")==""\n"
R"==(#if defined(IS_MAX))==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_MIN))==""\n"
R"==(#elif defined(IS_MIN))==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_MAX))==""\n"
R"==(#elif defined(IS_MUL))==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_ONE))==""\n"
R"==(#else)==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_ZERO))==""\n"
R"==(#endif)==""\n"
R"==(#if defined(SRC_DT_S8) || defined(SRC_DT_U8) || defined(SRC_DT_S32))==""\n"
R"==(#define MAX_FUNC max)==""\n"
R"==(#define MIN_FUNC min)==""\n"
R"==(#else)==""\n"
R"==(#define MAX_FUNC fmax)==""\n"
R"==(#define MIN_FUNC fmin)==""\n"
R"==(#endif)==""\n"
R"==(#if defined(IS_MAX))==""\n"
R"==(#define ACCUMULATE_INITIAL(x, y) MAX_FUNC(x, y))==""\n"
R"==(#elif defined(IS_MIN))==""\n"
R"==(#define ACCUMULATE_INITIAL(x, y) MIN_FUNC(x, y))==""\n"
R"==(#elif defined(IS_MEAN) || defined(IS_SUM))==""\n"
R"==(#define ACCUMULATE_INITIAL(x, y) (x + y))==""\n"
R"==(#elif defined(IS_MUL))==""\n"
R"==(#define ACCUMULATE_INITIAL(x, y) (x * y))==""\n"
R"==(#else)==""\n"
R"==(#define ACCUMULATE_INITIAL(x, y) (x + pow(fabs(y), POWER)))==""\n"
R"==(#endif)==""\n"
R"==(#if defined(IS_MAX) || defined(IS_MIN) || defined(IS_MEAN) || defined(IS_MUL))==""\n"
R"==(#define ACCUMULATE_FURTHER ACCUMULATE_INITIAL)==""\n"
R"==(#else)==""\n"
R"==(#define ACCUMULATE_FURTHER(x, y) (x + y))==""\n"
R"==(#endif)==""\n"
R"==(#if IS_FIRST)==""\n"
R"==(#define ACCUMULATE ACCUMULATE_INITIAL)==""\n"
R"==(#else)==""\n"
R"==(#define ACCUMULATE ACCUMULATE_FURTHER)==""\n"
R"==(#endif)==""\n"
R"==(#if defined(IS_MEAN))==""\n"
R"==(#define FINALIZE(x) (x / DIV))==""\n"
R"==(#elif defined(IS_LP_MAX))==""\n"
R"==(#define FINALIZE(x) rootn(fmax(x, EPS), POWER))==""\n"
R"==(#elif defined(IS_LP_SUM))==""\n"
R"==(#define FINALIZE(x) rootn(x + EPS, POWER))==""\n"
R"==(#elif defined(IS_P_MAX))==""\n"
R"==(#define FINALIZE(x) fmax(x, EPS))==""\n"
R"==(#elif defined(IS_P_SUM))==""\n"
R"==(#define FINALIZE(x) (x + EPS))==""\n"
R"==(#else)==""\n"
R"==(#define FINALIZE(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#define BLOCK_READ_DATA_T(data_ptr) \)==""\n"
R"==(AS_VECT_DATA_T(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)data_ptr)))==""\n"
R"==(#define BLOCK_READ_DATA_T(data_ptr) \)==""\n"
R"==(AS_VECT_DATA_T(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)data_ptr)))==""\n"
R"==(#define READ_DATA(val) WITH_BLOCK_READ ? BLOCK_READ_DATA_T(&val) : val)==""\n"
R"==(#if NUM_SRC_ZPAD > 2 || NUM_DST_ZPAD > 2)==""\n"
R"==(#error "At most 2 zero pad patterns permitted")==""\n"
R"==(#endif)==""\n"
R"==(bool is_dst_zero_padded(const dim_t dst_off) {)==""\n"
R"==(bool ret = false;)==""\n"
R"==(#if NUM_DST_ZPAD >= 1)==""\n"
R"==({)==""\n"
R"==(const dim_t outer_idx = (dst_off / DST_Z0_STRIDE1) % DST_Z0_SIZE1;)==""\n"
R"==(const dim_t inner_idx = (dst_off / DST_Z0_STRIDE0) % DST_Z0_SIZE0;)==""\n"
R"==(ret |= (outer_idx * DST_Z0_SIZE0 + inner_idx >= DST_Z0_SIZE);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if NUM_DST_ZPAD >= 2)==""\n"
R"==({)==""\n"
R"==(const dim_t outer_idx = (dst_off / DST_Z1_STRIDE1) % DST_Z1_SIZE1;)==""\n"
R"==(const dim_t inner_idx = (dst_off / DST_Z1_STRIDE0) % DST_Z1_SIZE0;)==""\n"
R"==(ret |= (outer_idx * DST_Z1_SIZE0 + inner_idx >= DST_Z1_SIZE);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(return ret;)==""\n"
R"==(})==""\n"
R"==(dim_t dst_off_w_zero_padding(dim_t outer, dim_t inner) {)==""\n"
R"==(dim_t outer_stride = INNER_DIM_SIZE;)==""\n"
R"==(#if NUM_DST_ZPAD >= 1 && DST_Z0_IS_REDUCED)==""\n"
R"==(#if DST_Z0_SIZE1 != 1 || DST_Z0_SIZE != 1)==""\n"
R"==(#error "Reduced zpad #1 doesn't match expected pattern!")==""\n"
R"==(#endif)==""\n"
R"==(outer_stride *= DST_Z0_SIZE0;)==""\n"
R"==(const dim_t inside0 = inner % DST_Z0_STRIDE0;)==""\n"
R"==(const dim_t idx0 = inner / DST_Z0_STRIDE0;)==""\n"
R"==(inner = inside0 + idx0 * DST_Z0_SIZE0 * DST_Z0_STRIDE0;)==""\n"
R"==(#endif)==""\n"
R"==(#if NUM_DST_ZPAD >= 2 && DST_Z1_IS_REDUCED)==""\n"
R"==(#if DST_Z1_SIZE1 != 1 || DST_Z1_SIZE != 1)==""\n"
R"==(#error "Reduced zpad #2 doesn't match expected pattern!")==""\n"
R"==(#endif)==""\n"
R"==(outer_stride *= DST_Z1_SIZE0;)==""\n"
R"==(const dim_t inside1 = inner % DST_Z1_STRIDE0;)==""\n"
R"==(const dim_t idx1 = inner / DST_Z1_STRIDE0;)==""\n"
R"==(inner = inside1 + idx1 * DST_Z1_SIZE0 * DST_Z1_STRIDE0;)==""\n"
R"==(#endif)==""\n"
R"==(return outer * outer_stride + inner;)==""\n"
R"==(})==""\n"
R"==(#define _SRC_OFF(outer, reduction, inner) \)==""\n"
R"==((outer) * REDUCTION_SIZE *INNER_DIM_SIZE + (reduction)*INNER_DIM_SIZE \)==""\n"
R"==(+ (inner))==""\n"
R"==(#define _DST_OFF(outer, inner) dst_off_w_zero_padding(outer, inner))==""\n"
R"==(#if REDUCE_VECTOR)==""\n"
R"==(#define FINAL_VEC_SIZE 1)==""\n"
R"==(#else)==""\n"
R"==(#define FINAL_VEC_SIZE VECT_DT_N)==""\n"
R"==(#endif)==""\n"
R"==(#if NUM_DST_ZPAD == 0)==""\n"
R"==(#define PADDED_NELEMS OUTER_SIZE *INNER_DIM_SIZE)==""\n"
R"==(#elif NUM_DST_ZPAD == 1)==""\n"
R"==(#define PADDED_NELEMS OUTER_SIZE *INNER_DIM_SIZE *DST_Z0_SIZE0 *DST_Z0_SIZE1)==""\n"
R"==(#elif NUM_DST_ZPAD == 2)==""\n"
R"==(#define PADDED_NELEMS \)==""\n"
R"==(OUTER_SIZE *INNER_DIM_SIZE *DST_Z0_SIZE0 *DST_Z0_SIZE1 *DST_Z1_SIZE0 \)==""\n"
R"==(*DST_Z1_SIZE1)==""\n"
R"==(#endif)==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_SIZE, 1, 1))) )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) )==""\n"
R"==(__kernel void)==""\n"
R"==(combined_reduce()==""\n"
R"==(__global SRC_DATA_T *src, __global DST_DATA_T *dst POST_OP_ARGS) {)==""\n"
R"==(const int sg_per_inner_dim)==""\n"
R"==(= div_up(div_up(INNER_DIM_SIZE, VECT_DT_N), SUBGROUP_SIZE);)==""\n"
R"==(const int inner_dims_per_sg)==""\n"
R"==(= min(REDUCTION_SIZE, max(1, SUBGROUP_SIZE / INNER_DIM_SIZE));)==""\n"
R"==(const int num_horiz_reductions = REDUCTION_SIZE / inner_dims_per_sg)==""\n"
R"==(/ (REDUCE_VECTOR ? VECT_DT_N : 1);)==""\n"
R"==(const int tail_reductions = REDUCTION_SIZE % inner_dims_per_sg;)==""\n"
R"==(const int sgid = get_global_id(0) / SUBGROUP_SIZE;)==""\n"
R"==(const int inner_idx_start)==""\n"
R"==(= (sgid % sg_per_inner_dim) * SUBGROUP_SIZE * VECT_DT_N;)==""\n"
R"==(const int outer_idx = sgid / sg_per_inner_dim;)==""\n"
R"==(const int sglid = get_sub_group_local_id();)==""\n"
R"==(const int inner_idx = inner_idx_start + (sglid % INNER_DIM_SIZE);)==""\n"
R"==(const int red_off = sglid / INNER_DIM_SIZE;)==""\n"
R"==(if (inner_idx >= INNER_DIM_SIZE)==""\n"
R"==(|| sglid >= INNER_DIM_SIZE * inner_dims_per_sg))==""\n"
R"==(return;)==""\n"
R"==(VECT_DEF_ACC_DATA_T acc = INIT_ACC;)==""\n"
R"==(const int loop_stride = _SRC_OFF()==""\n"
R"==(0, inner_dims_per_sg * (REDUCE_VECTOR ? VECT_DT_N : 1), 0);)==""\n"
R"==(int src_off = _SRC_OFF(outer_idx, WITH_BLOCK_READ ? 0 : red_off,)==""\n"
R"==(WITH_BLOCK_READ ? inner_idx_start : inner_idx);)==""\n"
R"==(__attribute__((opencl_unroll_hint(UNROLL_FACTOR))) )==""\n"
R"==(for (int off = 0; off < num_horiz_reductions;)==""\n"
R"==(off++, src_off += loop_stride) {)==""\n"
R"==(const VECT_DATA_T src_val = READ_DATA(src[src_off]);)==""\n"
R"==(acc = ACCUMULATE(acc, AS_VECT_DEF_ACC_DATA_T(src_val));)==""\n"
R"==(})==""\n"
R"==(if (red_off < tail_reductions) {)==""\n"
R"==(const VECT_DATA_T src_val = READ_DATA(src[src_off]);)==""\n"
R"==(acc = ACCUMULATE(acc, AS_VECT_DEF_ACC_DATA_T(src_val));)==""\n"
R"==(})==""\n"
R"==(local VECT_DEF_ACC_DATA_T local_acc[LWS_SIZE];)==""\n"
R"==(const int local_idx = (sgid * SUBGROUP_SIZE + sglid) % LWS_SIZE;)==""\n"
R"==(local_acc[local_idx] = acc;)==""\n"
R"==(if (sglid < INNER_DIM_SIZE) {)==""\n"
R"==(unroll_for(int i = 1; i < inner_dims_per_sg; i++) {)==""\n"
R"==(acc = ACCUMULATE_FURTHER()==""\n"
R"==(acc, local_acc[local_idx + i * INNER_DIM_SIZE]);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(if (sglid < INNER_DIM_SIZE) {)==""\n"
R"==(#if REDUCE_VECTOR)==""\n"
R"==(DEF_ACC_DATA_T final_acc[1] = {INIT_ACC};)==""\n"
R"==(for (int i = 0; i < VECT_DT_N; i++) {)==""\n"
R"==(final_acc[0] = ACCUMULATE_FURTHER(acc[i], final_acc[0]);)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(const DEF_ACC_DATA_T *final_acc = &acc;)==""\n"
R"==(#endif )==""\n"
R"==(for (int i = 0; i < FINAL_VEC_SIZE; i++) {)==""\n"
R"==(const dim_t dst_off)==""\n"
R"==(= _DST_OFF(outer_idx, inner_idx + i * SUBGROUP_SIZE);)==""\n"
R"==(#if IS_FINAL)==""\n"
R"==(float res = FINALIZE(convert_float(final_acc[i]));)==""\n"
R"==(#if WITH_POST_OP)==""\n"
R"==(float dst_val;)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(dst_val = DST_TO_REF(dst[dst_off]);)==""\n"
R"==(#endif )==""\n"
R"==(const int mb = (DST_S0 == 0))==""\n"
R"==(? 0)==""\n"
R"==(: dst_off / DST_S0 % div_up(DST_D0, DST_B0) * DST_B0)==""\n"
R"==(+ dst_off / DST_SB0 % DST_B0;)==""\n"
R"==(const int c = (DST_S1 == 0))==""\n"
R"==(? 0)==""\n"
R"==(: dst_off / DST_S1 % div_up(DST_D1, DST_B1) * DST_B1)==""\n"
R"==(+ dst_off / DST_SB1 % DST_B1;)==""\n"
R"==(const int d = (DST_S2 == 0))==""\n"
R"==(? 0)==""\n"
R"==(: dst_off / DST_S2 % div_up(DST_D2, DST_B2) * DST_B2)==""\n"
R"==(+ dst_off / DST_SB2 % DST_B2;)==""\n"
R"==(const int h = (DST_S3 == 0))==""\n"
R"==(? 0)==""\n"
R"==(: dst_off / DST_S3 % div_up(DST_D3, DST_B3) * DST_B3)==""\n"
R"==(+ dst_off / DST_SB3 % DST_B3;)==""\n"
R"==(const int w = (DST_S4 == 0))==""\n"
R"==(? 0)==""\n"
R"==(: dst_off / DST_S4 % div_up(DST_D4, DST_B4) * DST_B4)==""\n"
R"==(+ dst_off / DST_SB4 % DST_B4;)==""\n"
R"==(if (mb < DST_D0 && c < DST_D1 && d < DST_D2 && h < DST_D3)==""\n"
R"==(&& w < DST_D4) {)==""\n"
R"==(APPLY_POST_OPS_SERIAL(res, float, dst_val, float, mb, 1, c, 1,)==""\n"
R"==(d, 1, h, 1, w, 1, 0, 1);)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#else)==""\n"
R"==(float res = final_acc[i];)==""\n"
R"==(#endif )==""\n"
R"==(if (is_dst_zero_padded(dst_off)) res = 0.0f;)==""\n"
R"==(dst[dst_off] = IS_FINAL ? TO_DST(res) : res;)==""\n"
R"==(#if DST_Z0_IS_REDUCED && DST_Z1_IS_REDUCED)==""\n"
R"==(for (int i = 0; i < DST_Z0_SIZE0; i++) {)==""\n"
R"==(for (int j = 0; j < DST_Z1_SIZE0; j++) {)==""\n"
R"==(if (i == 0 && j == 0) continue;)==""\n"
R"==(dst[dst_off + i * DST_Z0_STRIDE0 + j * DST_Z1_STRIDE0])==""\n"
R"==(= TO_DST(0.0f);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#elif DST_Z0_IS_REDUCED)==""\n"
R"==(for (int i = 1; i < DST_Z0_SIZE0; i++) {)==""\n"
R"==(dst[dst_off + i * DST_Z0_STRIDE0] = TO_DST(0.0f);)==""\n"
R"==(})==""\n"
R"==(#elif DST_Z1_IS_REDUCED)==""\n"
R"==(for (int j = 1; j < DST_Z1_SIZE0; j++) {)==""\n"
R"==(dst[dst_off + j * DST_Z1_STRIDE0] = TO_DST(0.0f);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}