namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *ref_rnn_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2023 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/ocl/ocl_math_utils.h")==""\n"
R"==(#include "gpu/ocl/rnn/rnn_types.h")==""\n"
R"==(float one_m_square(float a) {)==""\n"
R"==(return 1.0f - a * a;)==""\n"
R"==(})==""\n"
R"==(float x_m_square(float a) {)==""\n"
R"==(return (1.0f - a) * a;)==""\n"
R"==(})==""\n"
R"==(float relu_fwd(float s, float alpha) {)==""\n"
R"==(return s > 0 ? s : s * alpha;)==""\n"
R"==(})==""\n"
R"==(float tanh_fwd(float s) {)==""\n"
R"==(return tanh(s);)==""\n"
R"==(})==""\n"
R"==(float logistic_fwd(float s) {)==""\n"
R"==(return 1 / (1 + exp((float)-s));)==""\n"
R"==(})==""\n"
R"==(float logistic_bwd(float s) {)==""\n"
R"==(return x_m_square(s);)==""\n"
R"==(})==""\n"
R"==(float relu_bwd(float s, float alpha) {)==""\n"
R"==(return s > 0 ? 1.f : alpha;)==""\n"
R"==(})==""\n"
R"==(float tanh_bwd(float s) {)==""\n"
R"==(return (1 - s) * (1 + s);)==""\n"
R"==(})==""\n"
R"==(float linear(float s, float alpha) {)==""\n"
R"==(return alpha * s;)==""\n"
R"==(})==""\n"
R"==(float relu_fwd_tm(float s, float alpha) {)==""\n"
R"==(#if !IS_TESTMODE)==""\n"
R"==(return relu_fwd(s, alpha);)==""\n"
R"==(#else)==""\n"
R"==(return linear(s, alpha);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(float tanh_fwd_tm(float s, float alpha) {)==""\n"
R"==(#if !IS_TESTMODE)==""\n"
R"==(return tanh(s);)==""\n"
R"==(#else)==""\n"
R"==(return linear(s, alpha);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(float logistic_fwd_tm(float s, float alpha) {)==""\n"
R"==(#if !IS_TESTMODE)==""\n"
R"==(return logistic_fwd(s);)==""\n"
R"==(#else)==""\n"
R"==(return linear(s, alpha);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(float relu_bwd_tm(float s, float alpha) {)==""\n"
R"==(#if !IS_TESTMODE)==""\n"
R"==(return relu_bwd(s, alpha);)==""\n"
R"==(#else)==""\n"
R"==(return linear(s, alpha);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(float tanh_bwd_tm(float s, float alpha) {)==""\n"
R"==(#if !IS_TESTMODE)==""\n"
R"==(return tanh_bwd(s);)==""\n"
R"==(#else)==""\n"
R"==(return linear(s, alpha);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(float logistic_bwd_tm(float s, float alpha) {)==""\n"
R"==(#if !IS_TESTMODE)==""\n"
R"==(return logistic_bwd(s);)==""\n"
R"==(#else)==""\n"
R"==(return linear(s, alpha);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(float activation_fwd(float s, float alpha, float cliping) {)==""\n"
R"==(#if CELL_KIND == VANILLA_RNN)==""\n"
R"==(#if ACTIVATION_KIND == ELTWISE_RELU)==""\n"
R"==(return relu_fwd_tm(s, alpha);)==""\n"
R"==(#elif ACTIVATION_KIND == ELTWISE_TANH)==""\n"
R"==(return tanh_fwd_tm(s, alpha);)==""\n"
R"==(#elif ACTIVATION_KIND == ELTWISE_LOGISTIC)==""\n"
R"==(return logistic_fwd_tm(s, alpha);)==""\n"
R"==(#else)==""\n"
R"==(#error "Unsupported activation_kind")==""\n"
R"==(#endif)==""\n"
R"==(#else)==""\n"
R"==(return 0.0f;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(float activation_bwd(float s, float alpha, float cliping) {)==""\n"
R"==(#if CELL_KIND == VANILLA_RNN)==""\n"
R"==(#if ACTIVATION_KIND == ELTWISE_RELU)==""\n"
R"==(return relu_bwd_tm(s, alpha);)==""\n"
R"==(#elif ACTIVATION_KIND == ELTWISE_TANH)==""\n"
R"==(return tanh_bwd_tm(s, alpha);)==""\n"
R"==(#elif ACTIVATION_KIND == ELTWISE_LOGISTIC)==""\n"
R"==(return logistic_bwd_tm(s, alpha);)==""\n"
R"==(#else)==""\n"
R"==(#error "Unsupported activation_kind")==""\n"
R"==(#endif)==""\n"
R"==(#else)==""\n"
R"==(return 0.0f;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) __kernel void)==""\n"
R"==(ref_rnn_copy_init_layer(__global WS_STATE_DATA_T *dst_base,)==""\n"
R"==(__global char *src_base, __global DIFF_DATA_T *scratch_diff_states,)==""\n"
R"==(int lr, int rl, int batch, int dhc, int slc, int n_iter, int n_layer,)==""\n"
R"==(int n_dir, int n_states, int states_ws_ld, int scratch_diff_states_ld,)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(int it_stride)==""\n"
R"==(#else)==""\n"
R"==(int it_stride, int b_stride)==""\n"
R"==(#endif)==""\n"
R"==() {)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(const int it = get_global_id(2);)==""\n"
R"==(const int b = get_global_id(1);)==""\n"
R"==(const int c = get_global_id(0);)==""\n"
R"==(if (c >= slc || b >= batch || it >= n_iter) return;)==""\n"
R"==(__global WS_STATE_DATA_T *dst;)==""\n"
R"==(__global WS_STATE_DATA_T *src = (__global WS_STATE_DATA_T *)src_base)==""\n"
R"==(+ src_l_off(it_stride, it) + b * slc + c;)==""\n"
R"==(if (lr) {)==""\n"
R"==(dst = dst_base)==""\n"
R"==(+ off_ws_state(n_layer, n_dir, n_iter, batch, states_ws_ld, 0,)==""\n"
R"==(0, it + 1, b, c);)==""\n"
R"==(dst[0] = src[0];)==""\n"
R"==(})==""\n"
R"==(if (rl) {)==""\n"
R"==(dst = dst_base)==""\n"
R"==(+ off_ws_state(n_layer, n_dir, n_iter, batch, states_ws_ld, 0,)==""\n"
R"==(n_dir - 1, n_iter - it, b, c);)==""\n"
R"==(dst[0] = src[0];)==""\n"
R"==(})==""\n"
R"==(#else )==""\n"
R"==(const int it = get_global_id(2);)==""\n"
R"==(const int b = get_global_id(1);)==""\n"
R"==(const int s = get_global_id(0);)==""\n"
R"==(if (s >= dhc || b >= batch || it >= n_iter) return;)==""\n"
R"==(__global DIFF_DATA_T *dst = scratch_diff_states;)==""\n"
R"==(const param4 strides = {it_stride, b_stride, 0, 0};)==""\n"
R"==(#if DIRECTION_KIND == CONCAT)==""\n"
R"==(__global DIFF_DATA_T *src)==""\n"
R"==(= (__global DIFF_DATA_T *)src_base + diff_dst_l_off(strides, it, b);)==""\n"
R"==(dst[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter, batch,)==""\n"
R"==(scratch_diff_states_ld, n_layer, 0, n_states, it, b, s)])==""\n"
R"==(= src[s];)==""\n"
R"==(dst[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter, batch,)==""\n"
R"==(scratch_diff_states_ld, n_layer, 1, n_states, n_iter - it - 1, b,)==""\n"
R"==(s)])==""\n"
R"==(= src[dhc + s];)==""\n"
R"==(#elif DIRECTION_KIND == SUM)==""\n"
R"==(__global DIFF_DATA_T *src)==""\n"
R"==(= (__global DIFF_DATA_T *)src_base + diff_dst_l_off(strides, it, b);)==""\n"
R"==(dst[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter, batch,)==""\n"
R"==(scratch_diff_states_ld, n_layer, 0, n_states, it, b, s)])==""\n"
R"==(= src[s];)==""\n"
R"==(dst[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter, batch,)==""\n"
R"==(scratch_diff_states_ld, n_layer, 1, n_states, n_iter - it - 1, b,)==""\n"
R"==(s)])==""\n"
R"==(= src[s];)==""\n"
R"==(#elif DIRECTION_KIND == L2R)==""\n"
R"==(__global DIFF_DATA_T *src)==""\n"
R"==(= (__global DIFF_DATA_T *)src_base + diff_dst_l_off(strides, it, b);)==""\n"
R"==(dst[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter, batch,)==""\n"
R"==(scratch_diff_states_ld, n_layer, 0, n_states, it, b, s)])==""\n"
R"==(= src[s];)==""\n"
R"==(#elif DIRECTION_KIND == R2L)==""\n"
R"==(__global DIFF_DATA_T *src = (__global DIFF_DATA_T *)src_base)==""\n"
R"==(+ diff_dst_l_off(strides, n_iter - it - 1, b);)==""\n"
R"==(dst[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter, batch,)==""\n"
R"==(scratch_diff_states_ld, n_layer, 0, n_states, it, b, s)])==""\n"
R"==(= src[s];)==""\n"
R"==(#else)==""\n"
R"==(#error "Unsupported direction_kind")==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(__kernel void ref_rnn_copy_init_iter(__global WS_STATE_DATA_T *dst_base,)==""\n"
R"==(__global AUX_DATA_T *dst_c_base, __global char *src_base,)==""\n"
R"==(__global char *src_c_base, __global char *scratch_diff_states,)==""\n"
R"==(int batch, int dhc, int sic, int n_iter, int n_layer, int n_dir,)==""\n"
R"==(int n_states, int states_ws_ld, int scratch_diff_states_ld,)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(int lay_stride, int dir_stride, int b_stride, int s_stride)==""\n"
R"==(#if WITH_SRC_ITER_C)==""\n"
R"==(,)==""\n"
R"==(int lay_c_stride, int dir_c_stride, int b_c_stride, int s_c_stride)==""\n"
R"==(#endif )==""\n"
R"==(,)==""\n"
R"==(const float shift, const float scale, const int quantize)==""\n"
R"==(#else )==""\n"
R"==(int lay_stride, int dir_stride, int b_stride, int s_stride)==""\n"
R"==(#if WITH_DST_ITER_C)==""\n"
R"==(,)==""\n"
R"==(int lay_c_stride, int dir_c_stride, int b_c_stride, int s_c_stride)==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==() {)==""\n"
R"==(const int s = get_global_id(0);)==""\n"
R"==(const int b = get_global_id(1);)==""\n"
R"==(const int lay = get_global_id(2) / n_dir;)==""\n"
R"==(const int dir = get_global_id(2) % n_dir;)==""\n"
R"==(const param4 strides = {lay_stride, dir_stride, b_stride, s_stride};)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(__global INPUT_DATA_T *src = (__global INPUT_DATA_T *)(src_base);)==""\n"
R"==(__global WS_STATE_DATA_T *dst = dst_base;)==""\n"
R"==(int ws_state_offset = off_ws_state()==""\n"
R"==(n_layer, n_dir, n_iter, batch, states_ws_ld, lay + 1, dir, 0, b, s);)==""\n"
R"==(if (s < sic) {)==""\n"
R"==(int src_i_offset = src_i_off(strides, lay, dir, b, s);)==""\n"
R"==(dst[ws_state_offset] = src_base)==""\n"
R"==(? (quantize ? TO_WS_STATE(src[src_i_offset] * scale + shift))==""\n"
R"==(: src[src_i_offset]))==""\n"
R"==(: TO_WS_STATE(0.0f);)==""\n"
R"==(})==""\n"
R"==(#if WITH_SRC_ITER_C)==""\n"
R"==(__global AUX_DATA_T *src_c = (__global AUX_DATA_T *)(src_c_base);)==""\n"
R"==(__global AUX_DATA_T *dst_c = dst_c_base;)==""\n"
R"==(if (s < dhc) {)==""\n"
R"==(const param4 c_strides)==""\n"
R"==(= {lay_c_stride, dir_c_stride, b_c_stride, s_c_stride};)==""\n"
R"==(dst_c[ws_state_offset] = src_c_base)==""\n"
R"==(? src_c[src_i_c_off(c_strides, lay, dir, b, s)])==""\n"
R"==(: TO_WS_STATE(0.0f);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#else )==""\n"
R"==(__global DIFF_DATA_T *src = (__global DIFF_DATA_T *)(src_base);)==""\n"
R"==(__global DIFF_DATA_T *dst = (__global DIFF_DATA_T *)scratch_diff_states;)==""\n"
R"==(if (s < dhc))==""\n"
R"==(dst[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter, batch,)==""\n"
R"==(scratch_diff_states_ld, lay, dir, 0, n_iter, b, s)])==""\n"
R"==(= src_base ? src[diff_dst_i_off(strides, lay, dir, b, s)])==""\n"
R"==(: 0.0f;)==""\n"
R"==(#if WITH_DST_ITER_C)==""\n"
R"==(__global DIFF_DATA_T *src_c = (__global DIFF_DATA_T *)(src_c_base);)==""\n"
R"==(if (s < dhc) {)==""\n"
R"==(const param4 c_strides)==""\n"
R"==(= {lay_c_stride, dir_c_stride, b_c_stride, s_c_stride};)==""\n"
R"==(dst[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter, batch,)==""\n"
R"==(scratch_diff_states_ld, lay, dir, 1, n_iter, b, s)])==""\n"
R"==(= src_c_base)==""\n"
R"==(? src_c[diff_dst_i_c_off(c_strides, lay, dir, b, s)])==""\n"
R"==(: 0.0f;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) __kernel void)==""\n"
R"==(ref_rnn_copy_res_layer(__global WS_STATE_DATA_T *src_base,)==""\n"
R"==(__global char *dst_base, __global char *scratch_diff_states, int lr,)==""\n"
R"==(int rl, int batch, int dhc, int slc, int n_iter, int n_layer, int n_dir,)==""\n"
R"==(int n_states, int states_ws_ld, int scratch_diff_states_ld,)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(int it_stride, int b_stride, int s_stride, const float shift,)==""\n"
R"==(const float scale, const int dequantize)==""\n"
R"==(#else)==""\n"
R"==(int it_stride, int b_stride, int s_stride)==""\n"
R"==(#endif)==""\n"
R"==() {)==""\n"
R"==(const int it = get_global_id(2);)==""\n"
R"==(const int b = get_global_id(1);)==""\n"
R"==(const int s = get_global_id(0);)==""\n"
R"==(const param4 strides = {it_stride, b_stride, s_stride, 0};)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(if (s >= dhc || b >= batch || it >= n_iter) return;)==""\n"
R"==(__global WS_STATE_DATA_T *src = src_base;)==""\n"
R"==(__global DST_DATA_T *dst = (__global DST_DATA_T *)(dst_base);)==""\n"
R"==(int dir = 0;)==""\n"
R"==(if (lr) {)==""\n"
R"==(bool dequantize_at_copy = dequantize && DIRECTION_KIND != SUM;)==""\n"
R"==(dst[dst_l_off(strides, it, b, dir * dhc + s)] = dequantize_at_copy)==""\n"
R"==(? TO_DST(((float)src[off_ws_state(n_layer, n_dir, n_iter, batch,)==""\n"
R"==(states_ws_ld, n_layer, dir, it + 1, b, s)])==""\n"
R"==(- shift))==""\n"
R"==(/ scale))==""\n"
R"==(: src[off_ws_state(n_layer, n_dir, n_iter, batch, states_ws_ld,)==""\n"
R"==(n_layer, dir, it + 1, b, s)];)==""\n"
R"==(dir = 1;)==""\n"
R"==(})==""\n"
R"==(if (rl) {)==""\n"
R"==(#if DIRECTION_KIND == SUM)==""\n"
R"==(if (dequantize) {)==""\n"
R"==(float val = (float)src[off_ws_state(n_layer, n_dir, n_iter, batch,)==""\n"
R"==(states_ws_ld, n_layer, dir, n_iter - it, b, s)])==""\n"
R"==(+ dst[dst_l_off(strides, it, b, s)];)==""\n"
R"==(val = min(max(val, 0.f), 255.f);)==""\n"
R"==(dst[dst_l_off(strides, it, b, s)])==""\n"
R"==(= TO_DST((val - 2 * shift) / scale);)==""\n"
R"==(} else {)==""\n"
R"==(#if defined(SRC_DT_U8) && defined(DST_DT_U8))==""\n"
R"==(dst[dst_l_off(strides, it, b, s)] = convert_uchar_sat()==""\n"
R"==(convert_short(src[off_ws_state(n_layer, n_dir, n_iter,)==""\n"
R"==(batch, states_ws_ld, n_layer, dir, n_iter - it, b,)==""\n"
R"==(s)]))==""\n"
R"==(+ convert_short(dst[dst_l_off(strides, it, b, s)]));)==""\n"
R"==(#else)==""\n"
R"==(ACC_DATA_T temp_src = DST_TO_REF(dst[dst_l_off(strides, it, b, s)]);)==""\n"
R"==(temp_src += DST_TO_REF(src[off_ws_state(n_layer, n_dir, n_iter,)==""\n"
R"==(batch, states_ws_ld, n_layer, dir, n_iter - it, b, s)]);)==""\n"
R"==(dst[dst_l_off(strides, it, b, s)] = REF_TO_DST(temp_src);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(dst[dst_l_off(strides, it, b, dir * dhc + s)] = dequantize)==""\n"
R"==(? TO_DST()==""\n"
R"==(((float)src[off_ws_state(n_layer, n_dir, n_iter, batch,)==""\n"
R"==(states_ws_ld, n_layer, dir, n_iter - it, b, s)])==""\n"
R"==(- shift))==""\n"
R"==(/ scale))==""\n"
R"==(: src[off_ws_state(n_layer, n_dir, n_iter, batch, states_ws_ld,)==""\n"
R"==(n_layer, dir, n_iter - it, b, s)];)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#else )==""\n"
R"==(if (s >= slc || b >= batch || it >= n_iter) return;)==""\n"
R"==(__global DIFF_DATA_T *src = (__global DIFF_DATA_T *)(scratch_diff_states);)==""\n"
R"==(__global DIFF_DATA_T *dst = (__global DIFF_DATA_T *)(dst_base);)==""\n"
R"==(int dir = 0;)==""\n"
R"==(#if DIRECTION_KIND == R2L)==""\n"
R"==(const int iter = n_iter - 1 - it;)==""\n"
R"==(#else)==""\n"
R"==(const int iter = it;)==""\n"
R"==(#endif)==""\n"
R"==(DIFF_DATA_T res = src[off_scratch_diff_states(n_layer, n_dir, n_states,)==""\n"
R"==(n_iter, batch, scratch_diff_states_ld, 0, 0, n_states, it, b, s)];)==""\n"
R"==(if (n_dir > 1) {)==""\n"
R"==(res += src[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter,)==""\n"
R"==(batch, scratch_diff_states_ld, 0, 1, n_states, n_iter - 1 - it,)==""\n"
R"==(b, s)];)==""\n"
R"==(})==""\n"
R"==(dst[diff_src_l_off(strides, iter, b, dir * slc + s)] = res;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(__kernel void ref_rnn_copy_res_iter(__global WS_STATE_DATA_T *src_base,)==""\n"
R"==(__global AUX_DATA_T *src_c_base, __global char *dst_base,)==""\n"
R"==(__global char *dst_c_base, __global char *scratch_diff_states,)==""\n"
R"==(int batch, int dhc, int sic, int n_iter, int n_layer, int n_dir,)==""\n"
R"==(int n_states, int states_ws_ld, int scratch_diff_states_ld,)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(int lay_stride, int dir_stride, int b_stride, int s_stride)==""\n"
R"==(#if WITH_DST_ITER_C)==""\n"
R"==(,)==""\n"
R"==(int lay_c_stride, int dir_c_stride, int b_c_stride, int s_c_stride)==""\n"
R"==(#endif )==""\n"
R"==(,)==""\n"
R"==(const float shift, const float scale, const int dequantize)==""\n"
R"==(#else )==""\n"
R"==(int lay_stride, int dir_stride, int b_stride, int s_stride)==""\n"
R"==(#if WITH_SRC_ITER_C)==""\n"
R"==(,)==""\n"
R"==(int lay_c_stride, int dir_c_stride, int b_c_stride, int s_c_stride)==""\n"
R"==(#endif )==""\n"
R"==(#endif)==""\n"
R"==() {)==""\n"
R"==(const int s = get_global_id(0);)==""\n"
R"==(const int b = get_global_id(1);)==""\n"
R"==(const int lay = get_global_id(2) / n_dir;)==""\n"
R"==(const int dir = get_global_id(2) % n_dir;)==""\n"
R"==(const param4 strides = {lay_stride, dir_stride, b_stride, s_stride};)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(__global WS_STATE_DATA_T *src = src_base;)==""\n"
R"==(__global OUTPUT_DATA_T *dst = (__global OUTPUT_DATA_T *)(dst_base);)==""\n"
R"==(if (dst_base && s < dhc) {)==""\n"
R"==(dst[dst_i_off(strides, lay, dir, b, s)] = dequantize)==""\n"
R"==(? TO_OUTPUT()==""\n"
R"==(((float)src[off_ws_state(n_layer, n_dir, n_iter, batch,)==""\n"
R"==(states_ws_ld, lay + 1, dir, n_iter, b, s)])==""\n"
R"==(- shift))==""\n"
R"==(/ scale))==""\n"
R"==(: TO_OUTPUT(src[off_ws_state(n_layer, n_dir, n_iter, batch,)==""\n"
R"==(states_ws_ld, lay + 1, dir, n_iter, b, s)]);)==""\n"
R"==(})==""\n"
R"==(#if WITH_DST_ITER_C)==""\n"
R"==(__global AUX_DATA_T *src_c = src_c_base;)==""\n"
R"==(__global AUX_DATA_T *dst_c = (__global AUX_DATA_T *)(dst_c_base);)==""\n"
R"==(const param4 c_strides)==""\n"
R"==(= {lay_c_stride, dir_c_stride, b_c_stride, s_c_stride};)==""\n"
R"==(if (dst_c_base && s < dhc) {)==""\n"
R"==(dst_c[dst_i_c_off(c_strides, lay, dir, b, s)])==""\n"
R"==(= src_c[off_ws_state(n_layer, n_dir, n_iter, batch,)==""\n"
R"==(states_ws_ld, lay + 1, dir, n_iter, b, s)];)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#else )==""\n"
R"==(__global DIFF_DATA_T *src = (__global DIFF_DATA_T *)(scratch_diff_states);)==""\n"
R"==(__global DIFF_DATA_T *dst = (__global DIFF_DATA_T *)(dst_base);)==""\n"
R"==(__global DIFF_DATA_T *dst_c = (__global DIFF_DATA_T *)(dst_c_base);)==""\n"
R"==(if (dst_base && s < sic) {)==""\n"
R"==(dst[diff_src_i_off(strides, lay, dir, b, s)])==""\n"
R"==(= src[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter,)==""\n"
R"==(batch, scratch_diff_states_ld, lay, dir, 0, 0, b, s)];)==""\n"
R"==(})==""\n"
R"==(#if WITH_SRC_ITER_C)==""\n"
R"==(if (dst_base && s < dhc) {)==""\n"
R"==(const param4 c_strides)==""\n"
R"==(= {lay_c_stride, dir_c_stride, b_c_stride, s_c_stride};)==""\n"
R"==(dst_c[diff_src_i_c_off(c_strides, lay, dir, b, s)])==""\n"
R"==(= src[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter,)==""\n"
R"==(batch, scratch_diff_states_ld, lay, dir, 1, 0, b, s)];)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(__kernel void ref_rnn_ws_set()==""\n"
R"==(__global char *ws, OFFTYPE ws_offset, float val, int ws_part) {)==""\n"
R"==(if (ws_part == WS_C_STATES || ws_part == WS_BIAS) {)==""\n"
R"==(__global DIFF_DATA_T *dst = (__global DIFF_DATA_T *)(ws + ws_offset);)==""\n"
R"==(dst[get_global_id(0)] = CONVERT_DATA_T(val);)==""\n"
R"==(} else if (ws_part == WS_GATES) {)==""\n"
R"==(__global ACC_DATA_T *dst = (__global ACC_DATA_T *)(ws + ws_offset);)==""\n"
R"==(dst[get_global_id(0)] = TO_ACC(val);)==""\n"
R"==(} else { )==""\n"
R"==(__global WS_STATE_DATA_T *dst)==""\n"
R"==(= (__global WS_STATE_DATA_T *)(ws + ws_offset);)==""\n"
R"==(dst[get_global_id(0)] = TO_WS_STATE(val);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if DEBUGPRINT)==""\n"
R"==(__kernel void ref_rnn_ws_print(__global ACC_DATA_T *gates_base,)==""\n"
R"==(__global WS_STATE_DATA_T *states_base,)==""\n"
R"==(__global AUX_DATA_T *c_states_base, __global AUX_DATA_T *bias_base,)==""\n"
R"==(__global ACC_DATA_T *grid_comp_base, int batch, int n_layer, int n_dir,)==""\n"
R"==(int n_iter, int n_bias, int dhc, int n_gates, int states_ws_ld,)==""\n"
R"==(int gates_ws_ld, int wic) {)==""\n"
R"==({)==""\n"
R"==(__global ACC_DATA_T *wt = gates_base;)==""\n"
R"==(printf("[lay,dir,iter,batch]\n");)==""\n"
R"==(for_(int j = 0; j < n_layer; j++))==""\n"
R"==(for_(int dir = 0; dir < n_dir; dir++))==""\n"
R"==(for_(int i = 0; i < n_iter; i++))==""\n"
R"==(for (int b = 0; b < batch; b++) {)==""\n"
R"==(printf("[%d,%d,%d,%d]: ", j, dir, i, b);)==""\n"
R"==(for_(int g = 0; g < n_gates; g++))==""\n"
R"==(for (int s = 0; s < dhc; s++) {)==""\n"
R"==(printf(" %f",)==""\n"
R"==(SRC_TO_REF(*(wt)==""\n"
R"==(+ off_ws_gates(n_dir, n_iter, batch,)==""\n"
R"==(gates_ws_ld, dhc, j, dir, i, b, g,)==""\n"
R"==(s))));)==""\n"
R"==(})==""\n"
R"==(printf("\n");)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==({)==""\n"
R"==(__global WS_STATE_DATA_T *wt = states_base;)==""\n"
R"==(printf("[lay,dir,iter]\n");)==""\n"
R"==(for_(int j = 0; j < n_layer + 1; j++))==""\n"
R"==(for_(int dir = 0; dir < n_dir; dir++))==""\n"
R"==(for (int i = 1; i < n_iter + 1; i++) {)==""\n"
R"==(printf("[%d,%d,%d] : ", j, dir, i);)==""\n"
R"==(for_(int b = 0; b < batch; b++))==""\n"
R"==(for (int s = 0; s < wic; s++) {)==""\n"
R"==(printf(" %f",)==""\n"
R"==(SRC_TO_REF(*(wt)==""\n"
R"==(+ off_ws_state(n_layer, n_dir, n_iter, batch,)==""\n"
R"==(states_ws_ld, j, dir, i, b, s))));)==""\n"
R"==(})==""\n"
R"==(printf("\n");)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if IS_TRAINING && CELL_KIND == LBR_GRU)==""\n"
R"==({)==""\n"
R"==(__global ACC_DATA_T *wt = grid_comp_base;)==""\n"
R"==(printf("[lay,dir,iter,batch]\n");)==""\n"
R"==(for_(int j = 0; j < n_layer; j++))==""\n"
R"==(for_(int dir = 0; dir < n_dir; dir++))==""\n"
R"==(for_(int i = 0; i < n_iter; i++))==""\n"
R"==(for (int b = 0; b < batch; b++) {)==""\n"
R"==(printf("[%d,%d,%d,%d]: ", j, dir, i, b);)==""\n"
R"==(for (int s = 0; s < dhc; s++) {)==""\n"
R"==(printf(" %f",)==""\n"
R"==(*(wt)==""\n"
R"==(+ off_ws_grid_offset(n_layer, n_dir, n_iter,)==""\n"
R"==(batch, dhc, j, dir, i, b, s)));)==""\n"
R"==(})==""\n"
R"==(printf("\n");)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if IS_FWD && CELL_KIND == VANILLA_LSTM)==""\n"
R"==({)==""\n"
R"==(__global AUX_DATA_T *wt = c_states_base;)==""\n"
R"==(printf("[lay,dir,iter]\n");)==""\n"
R"==(for_(int j = 0; j < n_layer; j++))==""\n"
R"==(for_(int dir = 0; dir < n_dir; dir++))==""\n"
R"==(for (int i = 0; i < n_iter + 1; i++) {)==""\n"
R"==(printf("[%d,%d,%d] : ", j, dir, i);)==""\n"
R"==(for_(int b = 0; b < batch; b++))==""\n"
R"==(for (int s = 0; s < wic; s++) {)==""\n"
R"==(printf(" %f",)==""\n"
R"==(*(wt)==""\n"
R"==(+ off_ws_state(n_layer, n_dir, n_iter, batch,)==""\n"
R"==(states_ws_ld, j, dir, i, b, s)));)==""\n"
R"==(})==""\n"
R"==(printf("\n");)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if COPY_BIAS)==""\n"
R"==({)==""\n"
R"==(__global AUX_DATA_T *wt = bias_base;)==""\n"
R"==(printf("[lay,dir]\n");)==""\n"
R"==(for_(int j = 0; j < n_layer; j++))==""\n"
R"==(for_(int dir = 0; dir < n_dir; dir++))==""\n"
R"==({)==""\n"
R"==(printf("[%d,%d] : ", j, dir);)==""\n"
R"==(for_(int nb = 0; nb < n_bias; nb++))==""\n"
R"==(for (int dhc_ = 0; dhc_ < dhc; dhc_++) {)==""\n"
R"==(printf(" %f",)==""\n"
R"==(*(wt)==""\n"
R"==(+ off_ws_bias(n_layer, n_dir, n_bias, dhc, j,)==""\n"
R"==(dir, nb, dhc_)));)==""\n"
R"==(})==""\n"
R"==(printf("\n");)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(__kernel void ref_rnn_bias_prepare(__global float *ws_bias,)==""\n"
R"==(__global float *scales, __global char *wei_layer,)==""\n"
R"==(__global char *wei_iter, __global float *bias, int dhc, int n_layer,)==""\n"
R"==(int n_dir, int n_bias, float data_shift, float data_scale,)==""\n"
R"==(int wei_l_comp_off, int wei_i_comp_off, int lay_stride, int dir_stride,)==""\n"
R"==(int nbias_stride, int dhc_stride) {)==""\n"
R"==(#if COPY_BIAS)==""\n"
R"==(const int dhc_ = get_global_id(0);)==""\n"
R"==(const int nbias_ = get_global_id(1);)==""\n"
R"==(const int layer_ = get_global_id(2) / n_dir;)==""\n"
R"==(const int dir_ = get_global_id(2) % n_dir;)==""\n"
R"==(const param4 strides = {lay_stride, dir_stride, nbias_stride, dhc_stride};)==""\n"
R"==(const float wei_scale)==""\n"
R"==(#if WEI_QPARAM_MASK)==""\n"
R"==(= scales[nbias_ * dhc + dhc_];)==""\n"
R"==(#else)==""\n"
R"==(= scales[0];)==""\n"
R"==(#endif)==""\n"
R"==(__global char *temp = (__global char *)(wei_iter + wei_i_comp_off);)==""\n"
R"==(__global float *wei_iter_comp)==""\n"
R"==(= (__global float *)(((unsigned long)temp + (sizeof(float) - 1)))==""\n"
R"==(& -sizeof(float));)==""\n"
R"==(temp = (__global char *)(wei_layer + wei_l_comp_off);)==""\n"
R"==(__global float *wei_layer_comp)==""\n"
R"==(= (__global float *)(((unsigned long)temp + (sizeof(float) - 1)))==""\n"
R"==(& -sizeof(float));)==""\n"
R"==(const int off = comp_off(n_dir, n_bias, dhc, layer_, dir_, nbias_, dhc_);)==""\n"
R"==(const float comp = wei_layer_comp[off] + wei_iter_comp[off];)==""\n"
R"==(ws_bias[off_ws_bias()==""\n"
R"==(n_layer, n_dir, n_bias, dhc, layer_, dir_, nbias_, dhc_)])==""\n"
R"==(= bias[bias_off(strides, layer_, dir_, nbias_, dhc_)])==""\n"
R"==(- comp * data_shift / (wei_scale * data_scale);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#if IS_INT8 && CELL_KIND == VANILLA_LSTM)==""\n"
R"==(WS_STATE_DATA_T q_d(float f, float data_scale, float data_shift) {)==""\n"
R"==(float qf = f * data_scale + data_shift;)==""\n"
R"==(return TO_WS_STATE(qf);)==""\n"
R"==(})==""\n"
R"==(float deq_w(ACC_DATA_T s, int gate, int j, __global float *scales,)==""\n"
R"==(float data_scale, int dhc) {)==""\n"
R"==(#if WEI_QPARAM_MASK)==""\n"
R"==(float wei_scale = scales[gate * dhc + j];)==""\n"
R"==(#else)==""\n"
R"==(float wei_scale = scales[0];)==""\n"
R"==(#endif)==""\n"
R"==(return (float)(s) / (wei_scale * data_scale);)==""\n"
R"==(})==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) __kernel void)==""\n"
R"==(ref_rnn_elemwise_fwd(int dir, int lay, int iter, __global char *scr_gates,)==""\n"
R"==(__global float *scales, __global float *bias_base, float alpha,)==""\n"
R"==(float data_shift, float data_scale, __global float *tm_scales,)==""\n"
R"==(__global WS_STATE_DATA_T *h_states_t_l, __global float *c_states_t_l,)==""\n"
R"==(__global float *c_states_tm1_l, __global AUX_DATA_T *ws_gates,)==""\n"
R"==(__global float *ws_bias, int states_ws_ld, int scratch_gates_ld,)==""\n"
R"==(int batch, int dhc, int n_layer, int n_dir, int n_bias,)==""\n"
R"==(int n_iter_scratch_gates, float tm_cscale) {)==""\n"
R"==(const int i = get_global_id(1); )==""\n"
R"==(const int j = get_global_id(0); )==""\n"
R"==(if (j >= dhc || i >= batch) return;)==""\n"
R"==(__global ACC_DATA_T *scratch_gates = (__global ACC_DATA_T *)(scr_gates))==""\n"
R"==(+ off_scratch_mem_iter()==""\n"
R"==(n_iter_scratch_gates, batch, scratch_gates_ld, dhc, iter);)==""\n"
R"==(float G0 = logistic_fwd_tm(deq_w(scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 0, j)],)==""\n"
R"==(0, j, scales, data_scale, dhc))==""\n"
R"==(+ ws_bias[off_ws_bias()==""\n"
R"==(n_layer, n_dir, n_bias, dhc, lay, dir, 0, j)],)==""\n"
R"==(tm_scales[0]);)==""\n"
R"==(float G1 = logistic_fwd_tm(deq_w(scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 1, j)],)==""\n"
R"==(1, j, scales, data_scale, dhc))==""\n"
R"==(+ ws_bias[off_ws_bias()==""\n"
R"==(n_layer, n_dir, n_bias, dhc, lay, dir, 1, j)],)==""\n"
R"==(tm_scales[1]);)==""\n"
R"==(float G2 = tanh_fwd_tm(deq_w(scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 2, j)],)==""\n"
R"==(2, j, scales, data_scale, dhc))==""\n"
R"==(+ ws_bias[off_ws_bias()==""\n"
R"==(n_layer, n_dir, n_bias, dhc, lay, dir, 2, j)],)==""\n"
R"==(tm_scales[2]);)==""\n"
R"==(float G3 = logistic_fwd_tm(deq_w(scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 3, j)],)==""\n"
R"==(3, j, scales, data_scale, dhc))==""\n"
R"==(+ ws_bias[off_ws_bias()==""\n"
R"==(n_layer, n_dir, n_bias, dhc, lay, dir, 3, j)],)==""\n"
R"==(tm_scales[3]);)==""\n"
R"==(float tmp)==""\n"
R"==(= G1 * c_states_tm1_l[cell_ws_state(states_ws_ld, i, j)] + G0 * G2;)==""\n"
R"==(h_states_t_l[cell_ws_state(states_ws_ld, i, j)])==""\n"
R"==(= q_d(G3 * tanh_fwd_tm(tmp, tm_cscale), data_scale, data_shift);)==""\n"
R"==(c_states_t_l[cell_ws_state(states_ws_ld, i, j)] = tmp;)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) __kernel void)==""\n"
R"==(ref_rnn_elemwise_fwd(int dir, int lay, int iter, __global char *scr_gates,)==""\n"
R"==(__global AUX_DATA_T *bias_base, float alpha, __global float *tm_scales,)==""\n"
R"==(__global WS_STATE_DATA_T *h_states_t_l,)==""\n"
R"==(__global AUX_DATA_T *c_states_t_l, __global AUX_DATA_T *c_states_tm1_l,)==""\n"
R"==(__global AUX_DATA_T *ws_gates, __global AUX_DATA_T *ws_grid,)==""\n"
R"==(int states_ws_ld, int gates_ws_ld, int scratch_gates_ld, int batch,)==""\n"
R"==(int dhc, int n_layer, int n_gates, int n_iter_scratch_gates,)==""\n"
R"==(int bias_lay_stride, int bias_dir_stride, int bias_s2, int bias_s3,)==""\n"
R"==(#if CELL_KIND == VANILLA_LSTM || CELL_KIND == VANILLA_RNN)==""\n"
R"==(float tm_cscale)==""\n"
R"==(#elif CELL_KIND == LBR_GRU)==""\n"
R"==(__global WS_STATE_DATA_T *h_states_tm_l, __global char *scr_cell)==""\n"
R"==(#elif CELL_KIND == VANILLA_GRU)==""\n"
R"==(__global WS_STATE_DATA_T *h_states_tm_l, int n_part)==""\n"
R"==(#endif)==""\n"
R"==() {)==""\n"
R"==(const int i = get_global_id(1); )==""\n"
R"==(const int j = get_global_id(0); )==""\n"
R"==(if (j >= dhc || i >= batch) return;)==""\n"
R"==(const param4 strides = {bias_lay_stride, bias_dir_stride, bias_s2, bias_s3};)==""\n"
R"==(const __global AUX_DATA_T *bias)==""\n"
R"==(= bias_base + bias_off(strides, lay, dir, 0, 0);)==""\n"
R"==(__global AUX_DATA_T *scratch_gates = (__global AUX_DATA_T *)(scr_gates))==""\n"
R"==(+ off_scratch_mem_iter()==""\n"
R"==(n_iter_scratch_gates, batch, scratch_gates_ld, dhc, iter);)==""\n"
R"==(#if CELL_KIND == VANILLA_LSTM)==""\n"
R"==(float g_i = logistic_fwd_tm((float)scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 0, j)])==""\n"
R"==(+ bias[off_ker_bias(n_gates, dhc, 0, j)],)==""\n"
R"==(tm_scales[0]);)==""\n"
R"==(float g_f = logistic_fwd_tm((float)scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 1, j)])==""\n"
R"==(+ bias[off_ker_bias(n_gates, dhc, 1, j)],)==""\n"
R"==(tm_scales[1]);)==""\n"
R"==(float g_z = tanh_fwd_tm((float)scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 2, j)])==""\n"
R"==(+ bias[off_ker_bias(n_gates, dhc, 2, j)],)==""\n"
R"==(tm_scales[2]);)==""\n"
R"==(float g_o = logistic_fwd_tm((float)scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 3, j)])==""\n"
R"==(+ bias[off_ker_bias(n_gates, dhc, 3, j)],)==""\n"
R"==(tm_scales[3]);)==""\n"
R"==(#if IS_TRAINING)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)] = g_i;)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 1, j)] = g_f;)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 2, j)] = g_z;)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 3, j)] = g_o;)==""\n"
R"==(#endif)==""\n"
R"==(float Ct = g_f * c_states_tm1_l[cell_ws_state(states_ws_ld, i, j)])==""\n"
R"==(+ g_i * g_z;)==""\n"
R"==(float Ht = g_o * tanh_fwd_tm(Ct, tm_cscale);)==""\n"
R"==(h_states_t_l[cell_ws_state(states_ws_ld, i, j)] = TO_INPUT(Ht);)==""\n"
R"==(c_states_t_l[cell_ws_state(states_ws_ld, i, j)] = Ct;)==""\n"
R"==(#elif CELL_KIND == VANILLA_RNN)==""\n"
R"==(float g = activation_fwd((float)scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 0, j)])==""\n"
R"==(+ bias[off_ker_bias(n_gates, dhc, 0, j)],)==""\n"
R"==(#if IS_TESTMODE)==""\n"
R"==(tm_scales[0], 0);)==""\n"
R"==(#else)==""\n"
R"==(alpha, 0);)==""\n"
R"==(#endif)==""\n"
R"==(#if IS_TRAINING)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)] = g;)==""\n"
R"==(#endif)==""\n"
R"==(h_states_t_l[cell_ws_state(states_ws_ld, i, j)] = TO_INPUT(g);)==""\n"
R"==(#elif CELL_KIND == LBR_GRU)==""\n"
R"==(__global AUX_DATA_T *scratch_cell = (__global AUX_DATA_T *)(scr_cell);)==""\n"
R"==(__global WS_STATE_DATA_T *src_iter = h_states_tm_l;)==""\n"
R"==(float Wh_b = (float)scratch_cell[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 2, j)])==""\n"
R"==(+ bias[off_ker_bias(n_gates, dhc, 3, j)];)==""\n"
R"==(float G0 = logistic_fwd_tm((float)scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 0, j)])==""\n"
R"==(+ (float)scratch_cell[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 0, j)])==""\n"
R"==(+ bias[off_ker_bias(n_gates, dhc, 0, j)],)==""\n"
R"==(tm_scales[0]);)==""\n"
R"==(float G1 = logistic_fwd_tm((float)scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 1, j)])==""\n"
R"==(+ (float)scratch_cell[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 1, j)])==""\n"
R"==(+ bias[off_ker_bias(n_gates, dhc, 1, j)],)==""\n"
R"==(tm_scales[1]);)==""\n"
R"==(float G2 = tanh_fwd_tm((float)scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 2, j)])==""\n"
R"==(+ G1 * Wh_b + bias[off_ker_bias(n_gates, dhc, 2, j)],)==""\n"
R"==(tm_scales[2]);)==""\n"
R"==(float Ht = G0 * TO_REF(src_iter[cell_ws_state(states_ws_ld, i, j)]))==""\n"
R"==(+ (1 - G0) * G2;)==""\n"
R"==(h_states_t_l[cell_ws_state(states_ws_ld, i, j)] = TO_INPUT(Ht);)==""\n"
R"==(#if IS_TRAINING)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)] = G0;)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 1, j)] = G1;)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 2, j)] = G2;)==""\n"
R"==(ws_grid[cell_ws_grid_comp(dhc, i, j)] = Wh_b;)==""\n"
R"==(#endif)==""\n"
R"==(#elif CELL_KIND == VANILLA_GRU)==""\n"
R"==(__global WS_STATE_DATA_T *src_iter = h_states_tm_l;)==""\n"
R"==(if (n_part == 1) {)==""\n"
R"==(float G0 = logistic_fwd_tm()==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 0, j)])==""\n"
R"==(+ bias[off_ker_bias(n_gates, dhc, 0, j)],)==""\n"
R"==(tm_scales[0]);)==""\n"
R"==(float G1 = logistic_fwd_tm()==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 1, j)])==""\n"
R"==(+ bias[off_ker_bias(n_gates, dhc, 1, j)],)==""\n"
R"==(tm_scales[1]);)==""\n"
R"==(/* TODO from CPU: Can be optimized for fwd_training by using)==""\n"
R"==(ws_gates instead of scratch_gates in p2 */)==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 0, j)])==""\n"
R"==(= TO_INPUT(G0);)==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 1, j)])==""\n"
R"==(= TO_INPUT(G1);)==""\n"
R"==(float tmp = TO_REF(src_iter[cell_ws_state(states_ws_ld, i, j)]);)==""\n"
R"==(h_states_t_l[cell_ws_state(states_ws_ld, i, j)] = TO_INPUT(tmp * G1);)==""\n"
R"==(#if IS_TRAINING)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)] = G0;)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 1, j)] = G1;)==""\n"
R"==(#endif)==""\n"
R"==(} else if (n_part == 2) {)==""\n"
R"==(float G0 = TO_REF(scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 0, j)]);)==""\n"
R"==(float G2 = tanh_fwd_tm()==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 2, j)])==""\n"
R"==(+ bias[off_ker_bias(n_gates, dhc, 2, j)],)==""\n"
R"==(tm_scales[2]);)==""\n"
R"==(float tmp = TO_REF(src_iter[cell_ws_state(states_ws_ld, i, j)]);)==""\n"
R"==(h_states_t_l[cell_ws_state(states_ws_ld, i, j)])==""\n"
R"==(= TO_INPUT(tmp * G0 + (1.0f - G0) * G2);)==""\n"
R"==(#if IS_TRAINING)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 2, j)] = G2;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(#error "Wrong Cell Kind")==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if NEED_BIAS_ATOMIC_REDUCE)==""\n"
R"==(#define MAYBE_ATOMIC volatile __global)==""\n"
R"==(#define DIFF_BIAS_DATA_T CONCAT2(atomic_, DIFF_DATA_T))==""\n"
R"==(#else)==""\n"
R"==(#define MAYBE_ATOMIC __global)==""\n"
R"==(#define DIFF_BIAS_DATA_T DIFF_DATA_T)==""\n"
R"==(#endif)==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) __kernel void)==""\n"
R"==(ref_rnn_elemwise_bwd(int dir, int lay, int iter, __global char *scr_gates,)==""\n"
R"==(__global AUX_DATA_T *bias_base, float alpha, __global float *tm_scales,)==""\n"
R"==(__global WS_STATE_DATA_T *states_tm1_l,)==""\n"
R"==(__global AUX_DATA_T *c_states_t_l, __global AUX_DATA_T *c_states_tm1_l,)==""\n"
R"==(__global AUX_DATA_T *ws_gates, __global AUX_DATA_T *ws_grid,)==""\n"
R"==(int states_ws_ld, int gates_ws_ld, int scratch_gates_ld, int batch,)==""\n"
R"==(int dhc, int n_layer, int n_gates, int n_iter_scratch_gates, int n_dir,)==""\n"
R"==(int n_states, int n_iter, int scratch_diff_states_ld,)==""\n"
R"==(#if CELL_KIND == VANILLA_LSTM || CELL_KIND == VANILLA_RNN)==""\n"
R"==(float tm_cscale,)==""\n"
R"==(#elif CELL_KIND == LBR_GRU)==""\n"
R"==(__global char *scr_gate_r,)==""\n"
R"==(#elif CELL_KIND == VANILLA_GRU)==""\n"
R"==(int n_part, __global char *scr_cell, __global char *scratch_dhG1,)==""\n"
R"==(#endif)==""\n"
R"==(__global DIFF_DATA_T *diff_states,)==""\n"
R"==(MAYBE_ATOMIC DIFF_BIAS_DATA_T *diff_bias_base, int lay_stride,)==""\n"
R"==(int dir_stride, int diff_bias_s2, int diff_bias_s3) {)==""\n"
R"==(#if !IS_FWD)==""\n"
R"==(const int i_ = get_global_id(1) * ELEMWISE_BWD_BATCH_BLOCK; )==""\n"
R"==(const int j = get_global_id(0); )==""\n"
R"==(const param4 strides = {lay_stride, dir_stride, diff_bias_s2, diff_bias_s3};)==""\n"
R"==(MAYBE_ATOMIC DIFF_BIAS_DATA_T *diff_bias)==""\n"
R"==(= diff_bias_base + diff_bias_off(strides, lay, dir, 0, 0);)==""\n"
R"==(if (j >= dhc) return;)==""\n"
R"==(DIFF_DATA_T diff_bias_acc[N_BIAS] = {0};)==""\n"
R"==(for (int batch_id = 0; batch_id < ELEMWISE_BWD_BATCH_BLOCK; batch_id++) {)==""\n"
R"==(int i = i_ + batch_id;)==""\n"
R"==(if (i >= batch) break;)==""\n"
R"==(#if CELL_KIND == VANILLA_LSTM)==""\n"
R"==(__global SRC_DATA_T *scratch_gates = (__global SRC_DATA_T *)(scr_gates))==""\n"
R"==(+ off_scratch_mem_iter(n_iter_scratch_gates, batch,)==""\n"
R"==(scratch_gates_ld, dhc, iter);)==""\n"
R"==(__global DIFF_DATA_T *diff_states_t_l = diff_states)==""\n"
R"==(+ off_scratch_diff_states(n_layer, n_dir, n_states, n_iter,)==""\n"
R"==(batch, scratch_diff_states_ld, lay, dir, 0, iter, 0, 0);)==""\n"
R"==(__global DIFF_DATA_T *diff_states_tp1_l = diff_states)==""\n"
R"==(+ off_scratch_diff_states(n_layer, n_dir, n_states, n_iter,)==""\n"
R"==(batch, scratch_diff_states_ld, lay, dir, 0, iter + 1, 0,)==""\n"
R"==(0);)==""\n"
R"==(__global DIFF_DATA_T *diff_states_t_lp1 = diff_states)==""\n"
R"==(+ off_scratch_diff_states(n_layer, n_dir, n_states, n_iter,)==""\n"
R"==(batch, scratch_diff_states_ld, lay + 1, dir, 0, iter, 0,)==""\n"
R"==(0);)==""\n"
R"==(float Ct = c_states_t_l[cell_ws_state(states_ws_ld, i, j)];)==""\n"
R"==(float tanhCt = tanh_fwd_tm(Ct, tm_cscale);)==""\n"
R"==(float dHt = (float)diff_states_tp1_l[cell_scratch_diff_states()==""\n"
R"==(n_iter, batch, scratch_diff_states_ld, 0, i, j)])==""\n"
R"==(+ diff_states_t_lp1[cell_scratch_diff_states()==""\n"
R"==(n_iter, batch, scratch_diff_states_ld, n_states, i, j)];)==""\n"
R"==(float dCt = (float)diff_states_tp1_l[cell_scratch_diff_states()==""\n"
R"==(n_iter, batch, scratch_diff_states_ld, 1, i, j)])==""\n"
R"==(+ one_m_square(tanhCt))==""\n"
R"==(* ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 3, j)])==""\n"
R"==(* dHt;)==""\n"
R"==(float dG1 = (float)c_states_tm1_l[cell_ws_state(states_ws_ld, i, j)])==""\n"
R"==(* dCt)==""\n"
R"==(* x_m_square()==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 1, j)]);)==""\n"
R"==(float dG0 = ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 2, j)] * dCt)==""\n"
R"==(* x_m_square()==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)]);)==""\n"
R"==(float dG3 = tanhCt * dHt)==""\n"
R"==(* x_m_square()==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 3, j)]);)==""\n"
R"==(float dG2 = ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)] * dCt)==""\n"
R"==(* one_m_square()==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 2, j)]);)==""\n"
R"==(diff_states_t_l[cell_scratch_diff_states()==""\n"
R"==(n_iter, batch, scratch_diff_states_ld, 1, i, j)])==""\n"
R"==(= dCt * ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 1, j)];)==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 0, j)])==""\n"
R"==(= TO_INPUT(dG0);)==""\n"
R"==(diff_bias_acc[0] += dG0;)==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 1, j)])==""\n"
R"==(= TO_INPUT(dG1);)==""\n"
R"==(diff_bias_acc[1] += dG1;)==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 2, j)])==""\n"
R"==(= TO_INPUT(dG2);)==""\n"
R"==(diff_bias_acc[2] += dG2;)==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 3, j)])==""\n"
R"==(= TO_INPUT(dG3);)==""\n"
R"==(diff_bias_acc[3] += dG3;)==""\n"
R"==(#if N_BIAS != 4)==""\n"
R"==(#error "Unexpected N_BIAS for VANILLA_LSTM")==""\n"
R"==(#endif)==""\n"
R"==(#elif CELL_KIND == LBR_GRU)==""\n"
R"==(__global SRC_DATA_T *scratch_gates = (__global SRC_DATA_T *)(scr_gates))==""\n"
R"==(+ off_scratch_mem_iter(n_iter_scratch_gates, batch,)==""\n"
R"==(scratch_gates_ld, dhc, iter);)==""\n"
R"==(__global SRC_DATA_T *scratch_gate_r)==""\n"
R"==(= (__global SRC_DATA_T *)(scr_gate_r);)==""\n"
R"==(__global DIFF_DATA_T *diff_src_iter = diff_states)==""\n"
R"==(+ off_scratch_diff_states(n_layer, n_dir, n_states, n_iter,)==""\n"
R"==(batch, scratch_diff_states_ld, lay, dir, 0, iter, 0, 0);)==""\n"
R"==(__global DIFF_DATA_T *diff_dst_iter = diff_states)==""\n"
R"==(+ off_scratch_diff_states(n_layer, n_dir, n_states, n_iter,)==""\n"
R"==(batch, scratch_diff_states_ld, lay, dir, 0, iter + 1, 0,)==""\n"
R"==(0);)==""\n"
R"==(__global DIFF_DATA_T *diff_dst_layer = diff_states)==""\n"
R"==(+ off_scratch_diff_states(n_layer, n_dir, n_states, n_iter,)==""\n"
R"==(batch, scratch_diff_states_ld, lay + 1, dir, 0, iter, 0,)==""\n"
R"==(0);)==""\n"
R"==(__global WS_STATE_DATA_T *src_iter )==""\n"
R"==(= states_tm1_l;)==""\n"
R"==(float h = TO_REF(src_iter[cell_ws_state(states_ws_ld, i, j)]);)==""\n"
R"==(float Wh_b = ws_grid[cell_ws_grid_comp(dhc, i, j)];)==""\n"
R"==(float dHt = diff_dst_iter[cell_scratch_diff_states()==""\n"
R"==(n_iter, batch, scratch_diff_states_ld, 0, i, j)])==""\n"
R"==(+ diff_dst_layer[cell_scratch_diff_states()==""\n"
R"==(n_iter, batch, scratch_diff_states_ld, n_states, i, j)];)==""\n"
R"==(float dG0 = (h - ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 2, j)]))==""\n"
R"==(* dHt)==""\n"
R"==(* x_m_square()==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)]);)==""\n"
R"==(float dG2 = (1.0f - ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)]))==""\n"
R"==(* one_m_square()==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 2, j)]))==""\n"
R"==(* dHt;)==""\n"
R"==(float dG1 = Wh_b * dG2)==""\n"
R"==(* x_m_square()==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 1, j)]);)==""\n"
R"==(diff_src_iter[cell_scratch_diff_states()==""\n"
R"==(n_iter, batch, scratch_diff_states_ld, 0, i, j)])==""\n"
R"==(= dHt * ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)];)==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 0, j)])==""\n"
R"==(= TO_INPUT(dG0);)==""\n"
R"==(diff_bias_acc[0] += dG0;)==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 1, j)])==""\n"
R"==(= TO_INPUT(dG1);)==""\n"
R"==(diff_bias_acc[1] += dG1;)==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 2, j)])==""\n"
R"==(= TO_INPUT(dG2);)==""\n"
R"==(diff_bias_acc[2] += dG2;)==""\n"
R"==(scratch_gate_r[cell_scratch_mem(scratch_gates_ld, dhc, i, 0, j)])==""\n"
R"==(= TO_INPUT(dG0);)==""\n"
R"==(scratch_gate_r[cell_scratch_mem(scratch_gates_ld, dhc, i, 1, j)])==""\n"
R"==(= TO_INPUT(dG1);)==""\n"
R"==(float tmp = dG2 * ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 1, j)];)==""\n"
R"==(scratch_gate_r[cell_scratch_mem(scratch_gates_ld, dhc, i, 2, j)])==""\n"
R"==(= TO_INPUT(tmp);)==""\n"
R"==(diff_bias_acc[3] += tmp;)==""\n"
R"==(#if N_BIAS != 4)==""\n"
R"==(#error "Unexpected N_BIAS for LBR_GRU")==""\n"
R"==(#endif)==""\n"
R"==(#elif CELL_KIND == VANILLA_RNN)==""\n"
R"==(__global AUX_DATA_T *ws_gates_run)==""\n"
R"==(= ws_gates + cell_ws_gates(gates_ws_ld, dhc, i, 0, j);)==""\n"
R"==(__global SRC_DATA_T *scratch_gates = (__global SRC_DATA_T *)(scr_gates))==""\n"
R"==(+ off_scratch_mem(n_iter_scratch_gates, batch, scratch_gates_ld,)==""\n"
R"==(dhc, iter, i, 0, j);)==""\n"
R"==(__global DIFF_DATA_T *diff_states_t_lp1 = diff_states)==""\n"
R"==(+ off_scratch_diff_states(n_layer, n_dir, n_states, n_iter,)==""\n"
R"==(batch, scratch_diff_states_ld, lay + 1, dir, n_states,)==""\n"
R"==(iter, i, j);)==""\n"
R"==(__global DIFF_DATA_T *diff_states_tp1_l = diff_states)==""\n"
R"==(+ off_scratch_diff_states(n_layer, n_dir, n_states, n_iter,)==""\n"
R"==(batch, scratch_diff_states_ld, lay, dir, 0, iter + 1, i,)==""\n"
R"==(j);)==""\n"
R"==(const float dH = (float)diff_states_t_lp1[0] + diff_states_tp1_l[0];)==""\n"
R"==(float g = ws_gates_run[0];)==""\n"
R"==(#if IS_TESTMODE)==""\n"
R"==(float tmp = = dH * activation_bwd(g, tm_scales[0], 0.);)==""\n"
R"==(scratch_gates[0] = TO_INPUT(tmp);)==""\n"
R"==(diff_bias_acc[0] += tmp;)==""\n"
R"==(#else)==""\n"
R"==(float tmp = dH * activation_bwd(g, alpha, 0.);)==""\n"
R"==(scratch_gates[0] = TO_INPUT(tmp);)==""\n"
R"==(diff_bias_acc[0] += tmp;)==""\n"
R"==(#endif)==""\n"
R"==(#if N_BIAS != 1)==""\n"
R"==(#error "Unexpected N_BIAS for VANILLA_RNN")==""\n"
R"==(#endif)==""\n"
R"==(#elif CELL_KIND == VANILLA_GRU)==""\n"
R"==(__global SRC_DATA_T *scratch_gates = (__global SRC_DATA_T *)(scr_gates))==""\n"
R"==(+ off_scratch_mem_iter(n_iter_scratch_gates, batch,)==""\n"
R"==(scratch_gates_ld, dhc, iter);)==""\n"
R"==(__global DIFF_DATA_T *diff_src_iter = diff_states)==""\n"
R"==(+ off_scratch_diff_states(n_layer, n_dir, n_states, n_iter,)==""\n"
R"==(batch, scratch_diff_states_ld, lay, dir, 0, iter, 0, 0);)==""\n"
R"==(__global DIFF_DATA_T *diff_dst_iter = diff_states)==""\n"
R"==(+ off_scratch_diff_states(n_layer, n_dir, n_states, n_iter,)==""\n"
R"==(batch, scratch_diff_states_ld, lay, dir, 0, iter + 1, 0,)==""\n"
R"==(0);)==""\n"
R"==(__global DIFF_DATA_T *diff_dst_layer = diff_states)==""\n"
R"==(+ off_scratch_diff_states(n_layer, n_dir, n_states, n_iter,)==""\n"
R"==(batch, scratch_diff_states_ld, lay + 1, dir, 0, iter, 0,)==""\n"
R"==(0);)==""\n"
R"==(__global WS_STATE_DATA_T *src_iter )==""\n"
R"==(= states_tm1_l;)==""\n"
R"==(float h = TO_REF(src_iter[cell_ws_state(states_ws_ld, i, j)]);)==""\n"
R"==(if (n_part == 1) {)==""\n"
R"==(float dHt = diff_dst_iter[cell_scratch_diff_states()==""\n"
R"==(n_iter, batch, scratch_diff_states_ld, 0, i, j)])==""\n"
R"==(+ diff_dst_layer[cell_scratch_diff_states(n_iter, batch,)==""\n"
R"==(scratch_diff_states_ld, n_states, i, j)];)==""\n"
R"==(float dG2 = (1.0f)==""\n"
R"==(- ws_gates[cell_ws_gates()==""\n"
R"==(gates_ws_ld, dhc, i, 0, j)]))==""\n"
R"==(* dHt)==""\n"
R"==(* one_m_square()==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 2, j)]);)==""\n"
R"==(float dG0 = (h - ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 2, j)]))==""\n"
R"==(* dHt)==""\n"
R"==(* x_m_square()==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)]);)==""\n"
R"==(diff_src_iter[cell_scratch_diff_states()==""\n"
R"==(n_iter, batch, scratch_diff_states_ld, 0, i, j)])==""\n"
R"==(= dHt * ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)];)==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 0, j)])==""\n"
R"==(= TO_INPUT(dG0);)==""\n"
R"==(diff_bias_acc[0] += dG0;)==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 2, j)])==""\n"
R"==(= TO_INPUT(dG2);)==""\n"
R"==(diff_bias_acc[2] += dG2;)==""\n"
R"==(} else if (n_part == 2) {)==""\n"
R"==(__global SRC_DATA_T *scratch_cell)==""\n"
R"==(= (__global SRC_DATA_T *)(scr_cell);)==""\n"
R"==(__global DIFF_DATA_T *dhG1 = (__global DIFF_DATA_T *)scratch_dhG1;)==""\n"
R"==(float dG1 = ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 1, j)];)==""\n"
R"==(diff_src_iter[cell_scratch_diff_states()==""\n"
R"==(n_iter, batch, scratch_diff_states_ld, 0, i, j)])==""\n"
R"==(+= dhG1[off_scratch_dhg1()==""\n"
R"==(batch, scratch_diff_states_ld, i, j)])==""\n"
R"==(* dG1;)==""\n"
R"==(float tmp = dhG1[off_scratch_dhg1()==""\n"
R"==(batch, scratch_diff_states_ld, i, j)])==""\n"
R"==(* h * x_m_square(dG1);)==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 1, j)])==""\n"
R"==(= TO_INPUT(tmp);)==""\n"
R"==(diff_bias_acc[1] += tmp;)==""\n"
R"==(scratch_cell[off_scratch_cell(batch, states_ws_ld, i, j)])==""\n"
R"==(= TO_INPUT(dG1 * h);)==""\n"
R"==(})==""\n"
R"==(#if N_BIAS != 3)==""\n"
R"==(#error "Unexpected N_BIAS for VANILLA_GRU")==""\n"
R"==(#endif)==""\n"
R"==(#else)==""\n"
R"==(#error "Wrong Cell Kind")==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(unroll_for(int k = 0; k < N_BIAS; k++) {)==""\n"
R"==(#if NEED_BIAS_ATOMIC_REDUCE)==""\n"
R"==(atomic_add_global(&diff_bias[k * dhc + j], diff_bias_acc[k]);)==""\n"
R"==(#else)==""\n"
R"==(diff_bias[k * dhc + j] += diff_bias_acc[k];)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}