namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *rnn_types_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2023 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_OCL_RNN_RNN_TYPES_H)==""\n"
R"==(#define GPU_OCL_RNN_RNN_TYPES_H)==""\n"
R"==(#include "gpu/ocl/ocl_types.h")==""\n"
R"==(#if OUTPUT_DT_U8)==""\n"
R"==(#define TO_OUTPUT(x) convert_uchar_sat_rte(x))==""\n"
R"==(#elif OUTPUT_DT_S8)==""\n"
R"==(#define TO_OUTPUT(x) convert_char_sat_rte(x))==""\n"
R"==(#elif OUTPUT_DT_S32)==""\n"
R"==(#define TO_OUTPUT(x) convert_int_sat_rte(x))==""\n"
R"==(#else)==""\n"
R"==(#define TO_OUTPUT(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#if INPUT_DT_BF16)==""\n"
R"==(#define TO_INPUT(x) cvt_f32_to_bf16(x))==""\n"
R"==(#define TO_REF(x) cvt_bf16_to_f32(x))==""\n"
R"==(#else)==""\n"
R"==(#define TO_INPUT(x) (x))==""\n"
R"==(#define TO_REF(x) (float)(x))==""\n"
R"==(#endif)==""\n"
R"==(#if DT_F16 && !IS_FWD)==""\n"
R"==(#error "FP16 is not supported for BWD")==""\n"
R"==(#endif)==""\n"
R"==(#define OFFTYPE ulong)==""\n"
R"==(#define TO_WS_STATE(x) TO_SRC(x))==""\n"
R"==(typedef struct param4 {)==""\n"
R"==(int s0;)==""\n"
R"==(int s1;)==""\n"
R"==(int s2;)==""\n"
R"==(int s3;)==""\n"
R"==(} param4;)==""\n"
R"==(#define OFF6(i0, D0, i1, D1, i2, D2, i3, D3, i4, D4, i5, D5) \)==""\n"
R"==(((((((i0) * (D1) + (i1)) * (D2) + (i2)) * (D3) + (i3)) * (D4) + (i4)) \)==""\n"
R"==(* (D5) \)==""\n"
R"==(+ (i5)))==""\n"
R"==(#define OFF5(i0, D0, i1, D1, i2, D2, i3, D3, i4, D4) \)==""\n"
R"==((((((i0) * (D1) + (i1)) * (D2) + (i2)) * (D3) + (i3)) * (D4) + (i4)))==""\n"
R"==(#define OFF4(i0, D0, i1, D1, i2, D2, i3, D3) \)==""\n"
R"==(((((i0) * (D1) + (i1)) * (D2) + (i2)) * (D3) + (i3)))==""\n"
R"==(#define OFF3(i0, D0, i1, D1, i2, D2) (((i0) * (D1) + (i1)) * (D2) + (i2)))==""\n"
R"==(#define OFF2(i0, D0, i1, D1) ((i0) * (D1) + (i1)))==""\n"
R"==(int comp_off(int n_dir, int n_bias, int dhc, int i0, int i1, int i2, int i3) {)==""\n"
R"==(return (((i0 * n_dir + i1) * n_bias + i2) * dhc + i3);)==""\n"
R"==(})==""\n"
R"==(int off_ws_state(int n_layer, int n_dir, int n_iter, int batch,)==""\n"
R"==(int states_ws_ld, int i0, int i1, int i2, int i3, int i4) {)==""\n"
R"==(return OFF5(i0, n_layer + 1, i1, n_dir, i2, n_iter + 1, i3, batch, i4,)==""\n"
R"==(states_ws_ld);)==""\n"
R"==(})==""\n"
R"==(int off_ws_gates(int n_dir, int n_iter, int batch, int gates_ws_ld, int dhc,)==""\n"
R"==(int i0, int i1, int i2, int i3, int i4, int i5) {)==""\n"
R"==(return i0 * n_dir * n_iter * batch * gates_ws_ld)==""\n"
R"==(+ i1 * n_iter * batch * gates_ws_ld + i2 * batch * gates_ws_ld)==""\n"
R"==(+ i3 * gates_ws_ld + i4 * dhc + i5;)==""\n"
R"==(})==""\n"
R"==(int off_ws_bias(int n_layer, int n_dir, int n_bias, int dhc, int i0, int i1,)==""\n"
R"==(int i2, int i3) {)==""\n"
R"==(return OFF4(i0, n_layer, i1, n_dir, i2, n_bias, i3, dhc);)==""\n"
R"==(})==""\n"
R"==(int off_ws_grid_offset(int n_layer, int n_dir, int n_iter, int batch, int dhc,)==""\n"
R"==(int i0, int i1, int i2, int i3, int i4) {)==""\n"
R"==(return OFF5(i0, n_layer + 1, i1, n_dir, i2, n_iter + 1, i3, batch, i4, dhc);)==""\n"
R"==(})==""\n"
R"==(int off_scratch_mem_iter(int n_iter_scratch_gates, int batch,)==""\n"
R"==(int scratch_gates_ld, int dhc, int iter) {)==""\n"
R"==(return (n_iter_scratch_gates == 1) ? 0 : iter * batch * scratch_gates_ld;)==""\n"
R"==(})==""\n"
R"==(int off_scratch_mem(int n_iter_scratch_gates, int batch, int scratch_gates_ld,)==""\n"
R"==(int dhc, int iter, int i1, int i2, int i3) {)==""\n"
R"==(return off_scratch_mem_iter()==""\n"
R"==(n_iter_scratch_gates, batch, scratch_gates_ld, dhc, iter))==""\n"
R"==(+ i1 * scratch_gates_ld + i2 * dhc + i3;)==""\n"
R"==(})==""\n"
R"==(int off_ker_bias(int n_gates, int dhc, int i0, int i1) {)==""\n"
R"==(return OFF2(i0, n_gates, i1, dhc);)==""\n"
R"==(})==""\n"
R"==(int off_scratch_diff_states(int n_layer, int n_dir, int n_states, int n_iter,)==""\n"
R"==(int batch, int scratch_diff_states_ld, int i0, int i1, int i2, int i3,)==""\n"
R"==(int i4, int i5) {)==""\n"
R"==(return OFF6(i0, n_layer + 1, i1, n_dir, i2, n_states + 1, i3, n_iter + 1,)==""\n"
R"==(i4, batch, i5, scratch_diff_states_ld);)==""\n"
R"==(})==""\n"
R"==(int off_scratch_dhg1(int batch, int scratch_diff_states_ld, int i0, int i1) {)==""\n"
R"==(return OFF2(i0, batch, i1, scratch_diff_states_ld);)==""\n"
R"==(})==""\n"
R"==(int off_scratch_cell(int batch, int states_ws_ld, int i0, int i1) {)==""\n"
R"==(return OFF2(i0, batch, i1, states_ws_ld);)==""\n"
R"==(})==""\n"
R"==(int cell_ws_state(int states_ws_ld, int i, int j) {)==""\n"
R"==(return i * states_ws_ld + j;)==""\n"
R"==(})==""\n"
R"==(int cell_ws_gates(int gates_ws_ld, int dhc, int i, int n, int j) {)==""\n"
R"==(return i * gates_ws_ld + n * dhc + j;)==""\n"
R"==(})==""\n"
R"==(int cell_ws_grid_comp(int dhc, int i3, int i4) {)==""\n"
R"==(return i3 * dhc + i4;)==""\n"
R"==(})==""\n"
R"==(int cell_scratch_mem(int scratch_gates_ld, int dhc, int i, int n, int j) {)==""\n"
R"==(return i * scratch_gates_ld + n * dhc + j;)==""\n"
R"==(})==""\n"
R"==(int cell_scratch_diff_states(int n_iter, int batch, int scratch_diff_states_ld,)==""\n"
R"==(int i2, int i4, int i5) {)==""\n"
R"==(return (((i2 * (n_iter + 1)) * batch + i4) * scratch_diff_states_ld + i5);)==""\n"
R"==(})==""\n"
R"==(int bias_off(param4 bias, int x0, int x1, int x2, int x3) {)==""\n"
R"==(return ((x0 % BIAS_B0) * BIAS_SB0 + (x0 / BIAS_B0) * bias.s0)==""\n"
R"==(+ (x1 % BIAS_B1) * BIAS_SB1 + (x1 / BIAS_B1) * bias.s1)==""\n"
R"==(+ (x2 % BIAS_B2) * BIAS_SB2 + (x2 / BIAS_B2) * bias.s2)==""\n"
R"==(+ (x3 % BIAS_B3) * BIAS_SB3 + (x3 / BIAS_B3) * bias.s3);)==""\n"
R"==(})==""\n"
R"==(int src_l_off(int src_l_s0, int iter) {)==""\n"
R"==(return ((iter % SRC_L_B0) * SRC_L_SB0 + (iter / SRC_L_B0) * src_l_s0);)==""\n"
R"==(})==""\n"
R"==(int src_i_off(param4 src_i, int x0, int x1, int x2, int x3) {)==""\n"
R"==(return ((x0 % SRC_I_B0) * SRC_I_SB0 + (x0 / SRC_I_B0) * src_i.s0)==""\n"
R"==(+ (x1 % SRC_I_B1) * SRC_I_SB1 + (x1 / SRC_I_B1) * src_i.s1)==""\n"
R"==(+ (x2 % SRC_I_B2) * SRC_I_SB2 + (x2 / SRC_I_B2) * src_i.s2)==""\n"
R"==(+ (x3 % SRC_I_B3) * SRC_I_SB3 + (x3 / SRC_I_B3) * src_i.s3);)==""\n"
R"==(})==""\n"
R"==(#if WITH_SRC_ITER_C)==""\n"
R"==(int src_i_c_off(param4 src_i_c, int x0, int x1, int x2, int x3) {)==""\n"
R"==(return ((x0 % SRC_I_C_B0) * SRC_I_C_SB0 + (x0 / SRC_I_C_B0) * src_i_c.s0)==""\n"
R"==(+ (x1 % SRC_I_C_B1) * SRC_I_C_SB1 + (x1 / SRC_I_C_B1) * src_i_c.s1)==""\n"
R"==(+ (x2 % SRC_I_C_B2) * SRC_I_C_SB2 + (x2 / SRC_I_C_B2) * src_i_c.s2)==""\n"
R"==(+ (x3 % SRC_I_C_B3) * SRC_I_C_SB3 + (x3 / SRC_I_C_B3) * src_i_c.s3);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(int dst_l_off(param4 dst_l, int x0, int x1, int x2) {)==""\n"
R"==(return ((x0 % DST_L_B0) * DST_L_SB0 + (x0 / DST_L_B0) * dst_l.s0)==""\n"
R"==(+ (x1 % DST_L_B1) * DST_L_SB1 + (x1 / DST_L_B1) * dst_l.s1)==""\n"
R"==(+ (x2 % DST_L_B2) * DST_L_SB2 + (x2 / DST_L_B2) * dst_l.s2);)==""\n"
R"==(})==""\n"
R"==(int dst_i_off(param4 dst_i, int x0, int x1, int x2, int x3) {)==""\n"
R"==(return ((x0 % DST_I_B0) * DST_I_SB0 + (x0 / DST_I_B0) * dst_i.s0)==""\n"
R"==(+ (x1 % DST_I_B1) * DST_I_SB1 + (x1 / DST_I_B1) * dst_i.s1)==""\n"
R"==(+ (x2 % DST_I_B2) * DST_I_SB2 + (x2 / DST_I_B2) * dst_i.s2)==""\n"
R"==(+ (x3 % DST_I_B3) * DST_I_SB3 + (x3 / DST_I_B3) * dst_i.s3);)==""\n"
R"==(})==""\n"
R"==(#if WITH_DST_ITER_C)==""\n"
R"==(int dst_i_c_off(param4 dst_i_c, int x0, int x1, int x2, int x3) {)==""\n"
R"==(return ((x0 % DST_I_C_B0) * DST_I_C_SB0 + (x0 / DST_I_C_B0) * dst_i_c.s0)==""\n"
R"==(+ (x1 % DST_I_C_B1) * DST_I_C_SB1 + (x1 / DST_I_C_B1) * dst_i_c.s1)==""\n"
R"==(+ (x2 % DST_I_C_B2) * DST_I_C_SB2 + (x2 / DST_I_C_B2) * dst_i_c.s2)==""\n"
R"==(+ (x3 % DST_I_C_B3) * DST_I_C_SB3 + (x3 / DST_I_C_B3) * dst_i_c.s3);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if !IS_FWD)==""\n"
R"==(int diff_src_l_off(param4 diff_src_l, int x0, int x1, int x2) {)==""\n"
R"==(return ((x0 % DIFF_SRC_L_B0) * DIFF_SRC_L_SB0)==""\n"
R"==(+ (x0 / DIFF_SRC_L_B0) * diff_src_l.s0)==""\n"
R"==(+ (x1 % DIFF_SRC_L_B1) * DIFF_SRC_L_SB1)==""\n"
R"==(+ (x1 / DIFF_SRC_L_B1) * diff_src_l.s1)==""\n"
R"==(+ (x2 % DIFF_SRC_L_B2) * DIFF_SRC_L_SB2)==""\n"
R"==(+ (x2 / DIFF_SRC_L_B2) * diff_src_l.s2);)==""\n"
R"==(})==""\n"
R"==(int diff_dst_l_off(param4 diff_dst_l, int iter, int batch) {)==""\n"
R"==(return ((iter % DIFF_DST_L_B0) * DIFF_DST_L_SB0)==""\n"
R"==(+ (iter / DIFF_DST_L_B0) * diff_dst_l.s0)==""\n"
R"==(+ (batch % DIFF_DST_L_B1) * DIFF_DST_L_SB1)==""\n"
R"==(+ (batch / DIFF_DST_L_B1) * diff_dst_l.s1);)==""\n"
R"==(})==""\n"
R"==(int diff_src_i_off(param4 diff_src_i, int x0, int x1, int x2, int x3) {)==""\n"
R"==(return ((x0 % DIFF_SRC_I_B0) * DIFF_SRC_I_SB0)==""\n"
R"==(+ (x0 / DIFF_SRC_I_B0) * diff_src_i.s0)==""\n"
R"==(+ (x1 % DIFF_SRC_I_B1) * DIFF_SRC_I_SB1)==""\n"
R"==(+ (x1 / DIFF_SRC_I_B1) * diff_src_i.s1)==""\n"
R"==(+ (x2 % DIFF_SRC_I_B2) * DIFF_SRC_I_SB2)==""\n"
R"==(+ (x2 / DIFF_SRC_I_B2) * diff_src_i.s2)==""\n"
R"==(+ (x3 % DIFF_SRC_I_B3) * DIFF_SRC_I_SB3)==""\n"
R"==(+ (x3 / DIFF_SRC_I_B3) * diff_src_i.s3);)==""\n"
R"==(})==""\n"
R"==(int diff_dst_i_off(param4 diff_dst_i, int x0, int x1, int x2, int x3) {)==""\n"
R"==(return ((x0 % DIFF_DST_I_B0) * DIFF_DST_I_SB0)==""\n"
R"==(+ (x0 / DIFF_DST_I_B0) * diff_dst_i.s0)==""\n"
R"==(+ (x1 % DIFF_DST_I_B1) * DIFF_DST_I_SB1)==""\n"
R"==(+ (x1 / DIFF_DST_I_B1) * diff_dst_i.s1)==""\n"
R"==(+ (x2 % DIFF_DST_I_B2) * DIFF_DST_I_SB2)==""\n"
R"==(+ (x2 / DIFF_DST_I_B2) * diff_dst_i.s2)==""\n"
R"==(+ (x3 % DIFF_DST_I_B3) * DIFF_DST_I_SB3)==""\n"
R"==(+ (x3 / DIFF_DST_I_B3) * diff_dst_i.s3);)==""\n"
R"==(})==""\n"
R"==(#if WITH_SRC_ITER_C)==""\n"
R"==(int diff_src_i_c_off(param4 diff_src_i_c, int x0, int x1, int x2, int x3) {)==""\n"
R"==(return ((x0 % DIFF_SRC_I_C_B0) * DIFF_SRC_I_C_SB0)==""\n"
R"==(+ (x0 / DIFF_SRC_I_C_B0) * diff_src_i_c.s0)==""\n"
R"==(+ (x1 % DIFF_SRC_I_C_B1) * DIFF_SRC_I_C_SB1)==""\n"
R"==(+ (x1 / DIFF_SRC_I_C_B1) * diff_src_i_c.s1)==""\n"
R"==(+ (x2 % DIFF_SRC_I_C_B2) * DIFF_SRC_I_C_SB2)==""\n"
R"==(+ (x2 / DIFF_SRC_I_C_B2) * diff_src_i_c.s2)==""\n"
R"==(+ (x3 % DIFF_SRC_I_C_B3) * DIFF_SRC_I_C_SB3)==""\n"
R"==(+ (x3 / DIFF_SRC_I_C_B3) * diff_src_i_c.s3);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_ITER_C)==""\n"
R"==(int diff_dst_i_c_off(param4 diff_dst_i_c, int x0, int x1, int x2, int x3) {)==""\n"
R"==(return ((x0 % DIFF_DST_I_C_B0) * DIFF_DST_I_C_SB0)==""\n"
R"==(+ (x0 / DIFF_DST_I_C_B0) * diff_dst_i_c.s0)==""\n"
R"==(+ (x1 % DIFF_DST_I_C_B1) * DIFF_DST_I_C_SB1)==""\n"
R"==(+ (x1 / DIFF_DST_I_C_B1) * diff_dst_i_c.s1)==""\n"
R"==(+ (x2 % DIFF_DST_I_C_B2) * DIFF_DST_I_C_SB2)==""\n"
R"==(+ (x2 / DIFF_DST_I_C_B2) * diff_dst_i_c.s2)==""\n"
R"==(+ (x3 % DIFF_DST_I_C_B3) * DIFF_DST_I_C_SB3)==""\n"
R"==(+ (x3 / DIFF_DST_I_C_B3) * diff_dst_i_c.s3);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(int diff_bias_off(param4 diff_bias, int x0, int x1, int x2, int x3) {)==""\n"
R"==(return ((x0 % DIFF_BIAS_B0) * DIFF_BIAS_SB0)==""\n"
R"==(+ (x0 / DIFF_BIAS_B0) * diff_bias.s0)==""\n"
R"==(+ (x1 % DIFF_BIAS_B1) * DIFF_BIAS_SB1)==""\n"
R"==(+ (x1 / DIFF_BIAS_B1) * diff_bias.s1)==""\n"
R"==(+ (x2 % DIFF_BIAS_B2) * DIFF_BIAS_SB2)==""\n"
R"==(+ (x2 / DIFF_BIAS_B2) * diff_bias.s2)==""\n"
R"==(+ (x3 % DIFF_BIAS_B3) * DIFF_BIAS_SB3)==""\n"
R"==(+ (x3 / DIFF_BIAS_B3) * diff_bias.s3);)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}